// контроль нуля идет на 1-е прерывание (это pin 3)
// Управление симистором для фазового регулятора мощности реализовано через PIN 36
// АЦП от трансформатора подключен на pin А2 (раньше шел на pin A3)
// Датчики ds18b20 сидят на 37 пине. (потому что на пины с 7 по 13 я подключил ULM2003, из-за желания использовать встроенный ШИМ в Ардуино)


// Кнопки подключены на следующие пины:
// почему на этих - да потому, что они рядом идут, и еще пин земли рядом, а гребенку 6 онтактов проще паять и подключать, чем каждый контакт одтельно
// PIN_SELECT 53
// PIN_RIGHT 51
// PIN_LEFT 49
// PIN_UP 45
// PIN_DOWN 47

// Почему-то иногда глючит дисплей - когда это происходит (на нем появляются иероглифы или перестает отображаться текст),
// нажать и держать одновременно клавишу влево и вправо, дисплей переинициализируется.

// одновременное нажатие кнопок вверх и вних позволчет перейти к следующему этапу процесса ректификации.


// Клапана для управления ШИМ подключены, начиная с PIN 22
// Всего максимум 5 клапанов, то есть на пины с 22 по 26 реализован
// программный ШИМ по количество полупериодов с контролем нуля.


// Дисплей на следующих пинах - почему на этих - да потому, что они рядом идут, и еще пин земли рядом, как раз для вывода R/W дисплея
// а гребенку из 7 контактов проще паять и подключать, чем каждый контакт одтельно
// LiquidCrystal lcd(52,50, 48, 46, 44, 42);

//#define TEST   // Раскомметировать, если нужно получать всяческие тестовые значения через Serial1
//#define TESTGSM   // Раскомметировать, если нужно дублировать входящюю информацияю из serial2 (сотового телефона) в Serial1 (для отладки)
//#define TESTRM   // Раскомметировать, если нужно получать тестовые значения регулятора мощности через Serial1

//#define TIMING  // Признак выдачи времени выполнения различных операций информации через Serial1 (раскомментировать, если нужно, но работа программы будет неправильной.

// Номер телефона
char my_phone[]="+77779987777";
#define PEREGREV_ON 1  // Того, что надо использовать режим работы клапана в режиме защиты от перегрева. 1- использовать, 0-нет.

#define NAPR_PEREGREV 150  // Какое среднеквадратичное надо поддерживать для защиты клапанов от перегрева.

#define USE_ALARM_UROVEN 0  // Нужно ли использовать датчик уровня в приемной емкости ардуино
#define USE_ALARM_VODA   0  // Нужно ли использовать датчик разлития воды ардуино

#if PEREGREV_ON==0
  #define PER_KLP_OPEN  1 // Подобранные периоды для открытия и закрытия клапанов так, чтобы клапан не перегревался и 
  #define PER_KLP_CLOSE 1 // чтобы не быо гидроударов
#else
  #define PER_KLP_OPEN  1000 // клапана на воду переводим в фазовое управление, чтобы раз в 10 секунд на них подавалось полное напряжение, а затем напряжение
  #define PER_KLP_CLOSE 0    // из контанты NAPR_PEREGREV 150 
#endif
// Номер телефона
char sms_start[]="0410"; // SMS для старта (рестарта процесса), это большая русская буква А в формате UNICODE 
                        // (обязательно надо использовать русские буквы, чтобы SMS гарантированно пришел в формате UNICODE, другие программа 
                        // анализировать не может, точнее может, но надо заранее тогда знать, что придет последними 4 байтами в сообщении.
char sms_stop[]="0411"; // SMS для остановки процесса, это большая русская буква Б в формате UNICODE

char lastSMSState=0;    // Последнее отправленное состояние по SMS (Чтобы не отправлять его многократно)
char pdu_phone[14];  // Номер телефона в формате отправки SMS (заполняется автоматически)


#define STAB_RM 1  // Поставить 1, если программе пытаться стабилизировать регулятор мощности, путем запрета вывода информации на дисплей в момент работы, чтения температуры и т.д.
                   // Поставить 0, если идет отладка программы без подключенных датчиков, контроллера детектора нуля, схемы измерения текущего напряжения в сети. 

#include <LiquidCrystal.h>
#include <OneWire.h>

#include <EEPROM.h> 

#define PR_REWRITE_EEPROM 9  // Константа, которая содержит признак необходимости перезаписи энергонезависимой памяти (1-254). 
                             // При запуске программы, значение 0-го байта ЕЕПРОМ сравнивается с этим знначением, 
                             // и если они не совпадают, тогда энергонезависимая памиять переписывается текущими значениями переменных
                             // То есть для перезаписи контанты при первом запуске, ее значение надо поменять

unsigned int ee_addr; // Переменная для хранения текущего адреса чтения/записи в EEPROM

unsigned char eeReadChar()
  {
    unsigned char lByte = EEPROM.read(ee_addr);
    ee_addr++;
    return lByte;
  }

void eeWriteChar(char p_value)
  {
    if (EEPROM.read(ee_addr)!=p_value)
                      EEPROM.write(ee_addr, p_value);
    ee_addr++;
  }

void eeWriteInt(int p_value)
  {
    unsigned char lByte = (unsigned char) (p_value);
    unsigned char hByte =(unsigned char) (p_value >> 8);
    
    // Для экономии ресурса памяти, сначала проверяем ее содержимое и запись производим только если значение отличается.
    eeWriteChar(lByte);
    eeWriteChar(hByte);
  }

//This function will read a 2 byte integer from the eeprom at the specified address and address + 1
unsigned int eeReadInt()
  {
    unsigned char lByte = eeReadChar();
    unsigned char hByte = eeReadChar();
    return (unsigned int) (lByte) | (unsigned int)  (hByte << 8);
  }
        

#define MAX_INDEX_INPUT 70

#define BEEP_LONG 20   //Длительность сигнала оповещения о состояниях процесса

unsigned int data_adc[MAX_INDEX_INPUT+1];
unsigned int tic_adc[MAX_INDEX_INPUT+1];
char lcd_buffer[33]; //Буфер для хранения данных для вывода на дисплей

#define MY_RX_BUFFER_SIZE 70
#define MY_TX_BUFFER_SIZE 50
char my_rx_buffer[MY_RX_BUFFER_SIZE];
char my_tx_buffer[MY_TX_BUFFER_SIZE];
char pos_rx_buffer=0;

int  FlState=0;  // Флаг состоянияч конечного автомата обработки нажатия кнопок клавиатуры 
unsigned char  IspReg=101; // Используемый в данный момент режим (по умолчанию пока ставим регулятор мощности)
char  DispPage=0; // Какую страницу отображать на дисплее
int TempTerm=200;
int Delta=10;
char FlToGSM=0;        // Признак того, что сотовый используется для вывода информации
char FlToUSART=0;      // Признак того, что CОМ-порт используется для вывода информации
char BeepEndProcess=0; // Пищать динамиком по окончании процесса.
char BeepStateProcess=0; // Пищать динамиком при переходе между процессами.
char BeepKeyPress=0; // Пищать динамиком при нажатии на клавиши
int Temp1P=987;        // Температура первой (недробной) перегонки 
int Temp2P=964;        // Температура второй  перегонки  (дистилляция без дефлегматора)
int Temp3P=954;        // Температура третьей перегонки  (дистилляция без дефлегматора)
int PowerGlvDistil=800; // Мощность отбора голов при простой дистилляции
int PowerDistil=3000; // Мощность дистилляции
int PowerRazvZerno=1000; // Мощность, при которой будут развариваться зерновые.

int TempDeflBegDistil=700; //Температура в дефлегматоре, для начала подачи воды в холодильник.
int TempDefl=820; //Температура в дефлегматоре, которую надо поддерживать путем включения клапана дефлегматора
unsigned char DeltaDefl=20; //дельта Температуры в дефлегматоре, которую надо поддерживать путем включения клапана дефлегматора
int tEndDistDefl=985;       // Температура в кубе, при которой надо прекращать дистилляцию с дефлегматором 

int tEndRectRazgon=830;     // Температура окончания режима разгона 83.0 С
int PowerRect=1000;     // Мощность ректификации
int tStabSR;// Температура, относительно которой стабилизируется отбор СР
char ProcChimSR;// Текущий процент отбора СР
unsigned int SecTempPrev;// Знчение секудндомера, при котором было считана эта температура.
int TempPrev=0;// Время Предыдущей температуры (для сверки с текущей (проверка стабилизации значение 344 для облегчения отладки)

int tEndRectOtbGlv=854;     // Температура окончания отбора голов 85.4 С
unsigned int timeChimRectOtbGlv=2000;  // Шим отбора голов (в полупериодах сетевого напряжения в данном случае это около 20 секунд)
unsigned char ProcChimOtbGlv=5;  // Процент ШИМ отбора голов (в данном случае это 5 процентов)
unsigned int timeChimRectOtbSR=1000;  // Шим отбора голов (в полупериодах сетевого напряжения в данном случае это около 10 секунд)
unsigned char tDeltaRect=10;  // Дельта ректификации (в десятых градуса Цельсия) в данном случае - это 10 десятых, то есть 1 градус Цельсия
unsigned int tEndRectOtbSR=965;  // Температура окончания отбора спирта-ректификата и начала отбора хвостов (в данном случе 96.5 С)
unsigned int tEndRect=995;       // Температура в кубе, при которой прекращается ректификация (в данном случе 99.5 С)
unsigned char minProcChimOtbSR=20;  // Минимальный ШИМ, за который нельзя выходить при отборе СР

char StateMachine=0; // Состояние конечного автомата процесса 
char flNeedReadAlarm;// Флаг того, что нужно анализировать состояние датчиков НПГ, Уровня в приемной емкости, Разлития по полу.
char flAlarmUroven=0;// Флаг того, что уровень в приемной емкости достик предела

char FlUsart=0; // Признак того, что надо вывести информацию на СОМ-порт
char flRing=0; // Признак наличия звонка от своего номера (запрос на СМС о состоянии процесса);

char flNeedAnalyse=0; // Флаг того, что надо анализировать результат измерения температуры
//char flStateProcess=0;
//char flNeedScanKbd=0; // Флаг того, что надо читать состояние клавиш 
char CountKeys;       // Переменная для защиты от дребезга
char CountState=0; // Флаг того, что сохраняем состояние процесса (каждое значение - это полсекунды)


#define MAX_KLP 5       // Количество клапанов, которыми надо управлять по ШИМ. 
#define PIN_KLP_BEG 22  // Начальный пин для управления клапанами 

#define KLP_NPG  0      // Номер клапана для управления НПГ (при дистилляции) 
#define KLP_VODA 1      // Номер клапана для управления общей подачей воды в систему
#define KLP_DEFL 2      // Номер клапана для подачи воды в дейфлегматор
#define KLP_GLV_HVS  3  // Номер клапана отбора головных и хвостовых фракций
#define KLP_SR   4      // Номер клапана отбора ректификата
#define KLP_HLD  3      // Номер клапана холодильника (для дистилляции)

#define TEMP_KUB  0      // Номер датчика  термометра в кубе
#define TEMP_RK20 1      // Номер датчика термометра в РК 20 см от насадки
#define TEMP_TSA  2      // Номер термометра в трубке связи с атмосферой
#define TEMP_DEFL 1      // Номер датчика  термометра в дефлегматоре
#define TEMP_TERMOSTAT 0 // Номер датчика  термометра термостата
#define TEMP_RAZVAR 0    // Номер датчика  термометра для разваривания зерновых


OneWire  ds(37);  // on pin 37
#define MAX_DS1820 5
unsigned char ds1820_devices;                  // Количество датчиков ds18b20 
unsigned char ds1820_rom_codes[MAX_DS1820][9]; // Коды датчиков ds18b20
char ds1820_popr[MAX_DS1820];                  // Поправки к температуре датчиков


unsigned int KlOpen[MAX_KLP];  // Время закрытия клапанов (в полупериодах, то есть 100 - это примерно 1 секунда)
unsigned int KlClose[MAX_KLP];// Время открытия клапанов  (в полупериодах,то есть 100 - это примерно 1 секунда)
char KlState[MAX_KLP];         // Состояние клапанов (1 открыт - 0 закрыт) 
unsigned int  KlCount[MAX_KLP]; // Счетчик состояния клапанов
char KlReg[MAX_KLP];         // Режим работы
char KlSelect=0;  // Выбран режим прибавления - либо время открытия, либо время закрытия - это для ручного управления ШИМом, тестирования и прочего
char KlTek=0;     // Для отладки - режим какого клапана отображать на дисплее  - это для ручного управления ШИМом, тестирования и прочего .  
char flSyncKLP=0; // Флаг того, что идет синхронизация клапанов, признак того, что состояние клапанов не менять.  

// Ну это понятно, это подключен LCDs
LiquidCrystal lcd(52,50, 48, 46, 44, 42);

int MaxVolts;
int MaxVoltsOut;
unsigned int SrVolts;     // Сумма значений напряжения
int SqVoltsCalibration;  // Среднеквадратичное для калибровки по вольметру
int CountSrVolts;        // Количество значений напряжения

int temps[MAX_DS1820];            // Температура датчиков  
unsigned char nPopr=0;                     // Текущий датчик, которому вносится поправка

#define PIN_TRIAC  36    // Управление симистором реализовано через PIN 36
#define PIN_SOUND 11    // На 11 пине сидит спикер от компа (мощная штука, 15 ом, потребляет 300ма, поэтому ей пока не злоупотребляю, может заменить ее в дальнейшем на Пьезо?)

#define PIN_REG_ON 30     // Пин для подачи напряжения на регулятор ТЭНа (может работать и без него)
#define PIN_RZG_ON 31    // Пин для включения режима разгона             (может работать и без него)
#define PIN_ALL_OFF 32    // Пин, при подаче напряжения на который вырыбаеся вообще все (например выключается УЗО) (может работать и без него)


int Counter1=0;
unsigned int Seconds;   // Текущее состояние времени с начала процесса;
int SecondsEnd;// Время окончания процесса 
char NeedDisplaying;
int result;
unsigned int CountTimer3=0;
unsigned int CompA3=16;      // Текущее значение для периодического вызова таймера 3.
unsigned char StateVolts=0;  // Состояние вычисление среднеквадратичного 
//0 - надо вычислить - запускается старт, 1 - вычисляется, 2 - вычислено, 3 - идет обработка рузультата
// 4 - Результат обработан, можно вычислять следующий
unsigned int index_input=0; // Текущий размер массива дла расчета среднеквадратичного

unsigned int SquareNapr;
char flFirstZero=1;
//unsigned int VoltsZr;
unsigned long TekPower;
unsigned long TekPowerKLP;
unsigned int TimeOpenTriac=0;
unsigned int TimeOpenTriacFact=0;
unsigned int TimeOpenKLP=0;
unsigned int CountTrans=0;
unsigned int TicZero; // Количество тиков таймера от нуля до нуля.
unsigned int TicSqNapr; // Количество тиков таймера от нуля до нуля, на основании которого рассчитано среднеквадратичное
//char FirstRun;
// Установка мощности (Пока в виде переменных)

int Power=3000;       // Номинальная мощность ТЭНов
int UstPower=500;     // Нужно получить мощность от регулятора (текущая мощность)

int UstPowerReg=500;     // Мощность в режиме регулятора мощности

char flNeedTemp=0;    // Флаг того, что нужно читать температуру датчиков
char StepOut=0;       // Признак шага чтения температуры 0 - выдаем команду на запрос температуры
                      // 1 - читаем температуру


// Пины, на которых сидят кнопки
#define PIN_SELECT 53
#define PIN_RIGHT 51
#define PIN_LEFT 49
#define PIN_UP 45
#define PIN_DOWN 47

#define PRESS_SELECT digitalRead(PIN_SELECT)==0
#define PRESS_RIGHT  digitalRead(PIN_RIGHT)==0
#define PRESS_LEFT  digitalRead(PIN_LEFT)==0
#define PRESS_UP     digitalRead(PIN_UP)==0
#define PRESS_DOWN   digitalRead(PIN_DOWN)==0

#define NPG_UROVEN_PIN A7                          // Пин уровня НПГ.
#define NPG_UROVEN digitalRead(NPG_UROVEN_PIN)==0

#define PIN_ALARM_VODA   A5      // Пин, на котором сидит датчик разлития воды на полу (да какой датчик, два луженых провода).     
#define PIN_ALARM_UROVEN A6      // Пин, на котором сидит датчик уровня в приемной емкости (да какой датчик, два луженых провода).
#define UROVEN_ALARM 900        // Уровень сигнала, достижение котогого свидетельсвует о срабатывании аналогового датчика (в обычном состоянии он выведен на значение около 1000)
char CountAlarmVoda=0;          // Счетчик срабатываний датчика (если сработал три раза, тогда тревога)
char CountAlarmUroven=0;        // Счетчик срабатываний датчика (если сработал три раза, тогда тревога)

#define PIN_TERMOSTAT_ON  28    // Пин термостата, который включается при превышении температуры 
#define PIN_TERMOSTAT_OFF 29    // Пин термостата, который отключается при превышении температуры 

unsigned int BeepTime;

// Функция устанавливает пищалку на заданное время (в 1/125 секунды), то есть 125-это одна секунда.
void my_beep(unsigned int mBeepTime)
{
  analogWrite(PIN_SOUND, 127);  
  BeepTime=mBeepTime;
}

void setup() 
{
  unsigned char i;
  // set up the LCD's number of columns and rows: 

  Serial1.begin(9600);
  Serial2.begin(9600);
  lcd.begin(16, 2);
  
  // Print a message to the LCD.
  //  my_lcdprint("hello, world!");
//  analogReference(DEFAULT);
   
   analogReference(INTERNAL2V56);

  pinMode(PIN_TRIAC, OUTPUT);
  digitalWrite(PIN_TRIAC, HIGH);  
  pinMode(PIN_TERMOSTAT_ON, OUTPUT);
  pinMode(PIN_TERMOSTAT_OFF, OUTPUT);
  
//  digitalWrite(29, HIGH);  
//  pinMode(22, OUTPUT);
//  digitalWrite(22, HIGH);  
//  pinMode(25, OUTPUT);
//  digitalWrite(25, HIGH);  
//  pinMode(26, OUTPUT);
//  digitalWrite(26, HIGH);  
//  pinMode(24, OUTPUT);
//  digitalWrite(24, HIGH);  
  pinMode(NPG_UROVEN_PIN, INPUT);
  digitalWrite(NPG_UROVEN_PIN, HIGH);  



  pinMode(PIN_SELECT, INPUT);           // назначить выводу порт ввода
  digitalWrite(PIN_SELECT, HIGH);       // включить подтягивающий резистор
  
  pinMode(PIN_RIGHT, INPUT);           // назначить выводу порт ввода
  digitalWrite(PIN_RIGHT, HIGH);       // включить подтягивающий резистор
  
  pinMode(PIN_LEFT, INPUT);           // назначить выводу порт ввода
  digitalWrite(PIN_LEFT, HIGH);       // включить подтягивающий резистор
  
  pinMode(PIN_UP, INPUT);           // назначить выводу порт ввода
  digitalWrite(PIN_UP, HIGH);       // включить подтягивающий резистор
  
  pinMode(PIN_DOWN, INPUT);           // назначить выводу порт ввода
  digitalWrite(PIN_DOWN, HIGH);       // включить подтягивающий резистор
  
  
  // Проходим по клапанам и устанавливаем им ШИМ и настраиваем пины
  for(i=0;i<MAX_KLP;i++)
  {
    pinMode(PIN_KLP_BEG+i, OUTPUT);
    digitalWrite(PIN_KLP_BEG+i, LOW);  
    KlOpen[i]=2*(i+1);    // Два период открыт, шесть закрыт, это 
    KlClose[i]=6*(i+1);   // рассчитанный мной в первом приближении оптимальный режим работы клапана, когда он и не перегревается
                          // и дает 100% потока воды и не дает гидроударов в системе.  
                          // Значение управленпия клапанами даем разное (для тестирования)

    // Клапана зануляем                          
    KlOpen[i]=0;    
    KlClose[i]=10;   
    KlState[i]=0;          // Начальное состояние - клапан закрыт, счетчик 0
    KlCount[i]=0;  
  }
  
  attachInterrupt(1, zero_crosss_int, RISING);  // Устанавливаем на 1-е прерывание функцию (это pin 3) обработку от детектора нулюя сетевого напряжения
//  attachInterrupt(0, zero_crosss_trans, RISING);  // Устанавливаем на 0-е прерывание функцию (это pin 2) обработку от детектора нуля трансформатора.


  // Таймер 2 используется для подсчета числа секунд и, возможно, программного небыстрого ШИМа
  // Прерываение по этому таймеру будет вызываться 125 раз в секунду.
  // Timer/Counter 2 initialization
  // Clock source: System Clock
  // Clock value: 62,500 kHz
  // Mode: Normal top=0xFF
  // OC2A output: Disconnected
  // OC2B output: Disconnected
  TCCR2A=0x00;
  TCCR2B=0x07;
  TCNT2=0x00;
  OCR2A=0x7D;
  OCR2B=0x00;  
  //  // Timer/Counter 1 Interrupt(s) initialization
  TIMSK2=0x02;


  // Таймер 3 будет использоваться для такой, обычно очень несвойственной для него процедуры, как "замена" аппаратного прерывания АЦП.
  // (даже обидно для этих целей целый таймер задействовать!)
  // Timer/Counter 3 initialization
  // Clock source: System Clock
  // Clock value: 250,000 kHz
  // Mode: Normal top=0xFFFF
  // OC3A output: Discon.
  // OC3B output: Discon.
  // OC3C output: Discon.
  // Noise Canceler: Off
  // Input Capture on Falling Edge
  // Timer3 Overflow Interrupt: Off
  // Input Capture Interrupt: Off
  // Compare A Match Interrupt: On
  // Compare B Match Interrupt: Off
  // Compare C Match Interrupt: Off
  TCCR3A=0x00;
  TCCR3B=0x03;
  TCNT3H=0x00;
  TCNT3L=0x00;
  ICR3H=0x00;
  ICR3L=0x00;

  OCR3AH=0;
  OCR3AL=0x7;

  OCR3BH=0x00;
  OCR3BL=0x00;
  OCR3CH=0x00;
  OCR3CL=0x00;  
  // Timer/Counter 3 Interrupt(s) initialization
  TIMSK3=0x02;

  // Таймер 4 будет использоваться для подсчета числа тиков при вызове АЦП в расчете среднеквадратичного 
  // (поскольку непонятно, чего и сколько это занимает в Ардуино - исходный код разбирать неохота)
  // Timer/Counter 4 initialization
  // Clock source: System Clock
  // Clock value: 250,000 kHz
  // Mode: Normal top=0xFFFF
  // OC4A output: Discon.
  // OC4B output: Discon.
  // OC4C output: Discon.
  // Noise Canceler: Off
  // Input Capture on Falling Edge
  // Timer4 Overflow Interrupt: Off
  // Input Capture Interrupt: Off
  // Compare A Match Interrupt: Off
  // Compare B Match Interrupt: Off
  // Compare C Match Interrupt: Off
  TCCR4A=0x00;
  TCCR4B=0x03;
  TCNT4H=0x00;
  TCNT4L=0x00;
  ICR4H=0x00;
  ICR4L=0x00;
  OCR4AH=0x00;
  OCR4AL=0x00;
  OCR4BH=0x00;
  OCR4BL=0x00;
  OCR4CH=0x00;
  OCR4CL=0x00;
  // Timer/Counter 4 Interrupt(s) initialization
  TIMSK4=0x00;


  // Таймер 5 будет использоваться для управления симистором по прерыванию COMPA.
  // Timer/Counter 5 initialization
  // Clock source: System Clock
  // Clock value: 250,000 kHz
  // Mode: Normal top=0xFFFF
  // OC5A output: Discon.
  // OC5B output: Discon.
  // OC5C output: Discon.
  // Noise Canceler: Off
  // Input Capture on Falling Edge
  // Timer5 Overflow Interrupt: Off
  // Input Capture Interrupt: Off
  // Compare A Match Interrupt: On
  // Compare B Match Interrupt: Off
  // Compare C Match Interrupt: Off
  TCCR5A=0x00;
  TCCR5B=0x03;
  TCNT5H=0x00;
  TCNT5L=0x00;
  ICR5H=0x00;
  ICR5L=0x00;
  OCR5AH=0x00;
  OCR5AL=0x02;
  OCR5BH=0x00;
  OCR5BL=0x00;
  OCR5CH=0x00;
  OCR5CL=0x00;
  // Timer/Counter 5 Interrupt(s) initialization
  TIMSK5=0x06;


//  TekPower=(unsigned long) UstPower*220*220/ Power;
  StateVolts=0;
  
  ds1820_devices=0;
  while(ds.search(ds1820_rom_codes[ds1820_devices])) {
    ds1820_devices++;
  }
  ds.reset_search();
  lcd.clear();
  sprintf(lcd_buffer,"ds18B20Count=%u",ds1820_devices); //запись в буфер текста и значений температуры в подготовленном
  lcd.print(lcd_buffer);
  delay(2000);
  flNeedTemp=0;
  StepOut=0;
  for(i=0;i<ds1820_devices;i++)
  {
    temps[i]=0;
    ds1820_popr[i]=0;                  // Поправки к температуре датчиков устанавливаем в ноль (в дальнейшем они сами считаются из eeprom, если были ранее записаны).
  }
  
  // Читаем ранее сохраненные значения из энергонезависимой памяти.
  if (EEPROM.read(0)!=PR_REWRITE_EEPROM)
  { 
    writeEEPROM();
  }
  
  readEEPROM();
  
  // Писк динамиком на 11 Пине (заодно и проверю, как функция analogWrite работает - ее у меня, похоже, немного осталось, программой для своих целей 
  //не используется только таймер 0 и таймер 1, видимо можно пользоваться только
  // пинами 11 и 12, 13, судя по схеме.
//  analogWrite(PIN_SOUND, 125);  
//  delay(50);
//  analogWrite(PIN_SOUND, 0);    
  my_beep(1);
  if (IspReg>=1000) IspReg=101;
  
  #ifdef TESTGSM
  Serial2.println("ATD 1000");
  #endif
// Пин 12 и 13  тоже работает, но на пин 13 лучше динамик не садить, а то пищит противно при прошивке программы и еще наверное дает помехи.
//  analogWrite(13, 127);  
//  delay(20);
//  analogWrite(13, 0);    
 // Проверка функции  - эти функции не работают, видимо заняли прерывания, на которых они сидят, ничего, обойдемся.
//   noTone(PIN_SOUND);
//   tone(PIN_SOUND, 440, 200);  
  if (IspReg>=250) IspReg=101;
  // Выдаем тестовую команду
  Serial2.println("AT");
  delay(500);
  // включаем уведомление о входящих СМС.
  Serial2.println("AT+CNMI=1,1");
  delay(500);
  #ifdef TESTGSM
  Serial2.println("ATD 1000");
  delay(500);
  #endif
  // Получаем номер в формате ПДУ.
  GetPhonePDU();
// Пин 12 и 13  тоже работает, но на пин 13 лучше динамик не садить, а то пищит противно при прошивке программы и еще наверное дает помехи.
//  analogWrite(13, 127);  
//  delay(20);
//  analogWrite(13, 0);    
 // Проверка функции  - эти функции не работают, видимо заняли прерывания, на которых они сидят, ничего, обойдемся.
//   noTone(PIN_SOUND);
//   tone(PIN_SOUND, 440, 200);  
   CloseAllKLP();
   digitalWrite(PIN_REG_ON,LOW);
   digitalWrite(PIN_RZG_ON,LOW);
   digitalWrite(PIN_ALL_OFF,HIGH);
   digitalWrite(PIN_TERMOSTAT_ON,LOW);
   digitalWrite(PIN_TERMOSTAT_OFF,LOW);
}

// Прерывание управления симистором.
ISR(TIMER5_COMPA_vect) 
{
  // Включаем симистор
  if (UstPower>0)
  {
    digitalWrite(PIN_TRIAC, HIGH);  
    // ждем 20 мкс и выключаем симистор
    delayMicroseconds(20);       
  }
  digitalWrite(PIN_TRIAC, LOW);  
  
}

// Прерывание управления симистором клапанов подачи вод.
ISR(TIMER5_COMPB_vect) 
{
  char i;  
  for (i=0;i<MAX_KLP;i++)
  { // Если клапан в режиме ШИМ и Состояние клапана включен, то включаем его 
    if (KlReg[i]==1 && KlState[i]==1) digitalWrite(PIN_KLP_BEG+i, HIGH);  
  }
  
  delayMicroseconds(20);       
  
  for (i=0;i<MAX_KLP;i++)
  { // Если клапан в режиме ШИМ и Состояние клапана включен, то выключаем его 
    if (KlReg[i]==1 && KlState[i]==1) digitalWrite(PIN_KLP_BEG+i, LOW);  
  }
  
//  digitalWrite(PIN_KLP_BEG+1, HIGH);  
//  // ждем 20 мкс и выключаем симистор
//  delayMicroseconds(20);       
//  digitalWrite(PIN_KLP_BEG+1, LOW);  
  
}

// Прерывание по таймеру 3 для расчета выборки для среднеквадратичного
ISR(TIMER3_COMPA_vect) 
{
  unsigned int zn;
  unsigned int tic;
//  CountTimer3++; // Это для отладки, чтобы понять, что таймер вызывается и я правильно понял логику таймеров в Ардуино.

  // Здесь проявляется недостаток реалициации АЦП в Ардуино, если даже на Atmega16 c частотой 8Мгц, АЦП, реализованное через аппаратное прерывание успевает стабильно отловить ноль в одном и том же месте
  // то здесь ноль отлавивается в  немного отличающихся местах, на пару десатков тиков таймера.
  // Если бы измерение сетевого напряжения проводилось от резисторного делителя, а не от транформатора, то 0 АЦП соответсвовал бы переходу через 0 контроллера детектора нуля, и было бы проще, а так 
  // надо как-то организовать дополнительно прерывание по 0 именно от напряжения трансформатора, или подумать, как решить это программно.
  
  // Если дана команда начать расчет среднеквадратичного, то читаем значение АЦП.
  if (StateVolts==0 || StateVolts==1)
  {
    
    // В фунции analogRead(), судя по всему, используется delay, что приводит к "помаргиванию" регулятора, если вызов этой функции попадает на детектор нуля или еще како-нибудь важное
    // прерывание. Надо бы в дальнейшем учесть это и вызывать analogRead() только в том случае, когда переход через ноль еще далеко. (более 40 тиков таймера)
    result=analogRead(2); // читаем показания с pin А3
  }

  tic=(int) TCNT4L | (int) (TCNT4H<<8); // Расчитывааем текущее значение таймера


  if (result==0)
  {

    // Если дана команда рассчитать среднеквадратичное, или среднеквадратичное рассчитывается, но 0 встретился раньше, чем положено, то запускаем расчет заново.        
    if (StateVolts==0 || (StateVolts==1 && index_input<=20))
    {
      index_input=0;
      StateVolts=1; 
      tic=0;  
      MaxVolts=0;
      TCNT4H=0x00;
      TCNT4L=0x00;

    }  

    // Если ноль встретился и процесс расчета идет, тогда ставим флаг окончания процесса.
    if (StateVolts==1 && index_input>59)
    {                
      data_adc[index_input]=result;    
      tic_adc[index_input]= tic;
      index_input++;
//      NeedDisplaying=true;
      StateVolts=2;     
      MaxVoltsOut=MaxVolts;
    }                 

  }

  // Если процесси идет, тогда просто накапливаем значения измерений
  if (StateVolts==1)
  {
    data_adc[index_input]=result;   
    tic_adc[index_input]=tic;
    index_input++;
    if (result>MaxVolts)
    {  
      MaxVolts=result;
    }
  }


  // Если превышен размер массива, то считаем эту выборку несостоятельной (Вдруг глюк АЦП или помеха в сети), начинаем снова.
  if (index_input>=MAX_INDEX_INPUT)  StateVolts=0;

  // Сбрасываем таймер
  TCNT3H=0x00;
  TCNT3L=0x00;
}


// Прерывание вызывается 125 раз в секунду
ISR(TIMER2_COMPA_vect) 
{

  
  ScanKbd();

  if (BeepTime>1) BeepTime--;
  else
  {
    if (BeepTime==1) analogWrite(PIN_SOUND, 0);
    BeepTime=0;
  }

//  flNeedScanKbd=1;

  // Следим за защитой от дребезга клавиш
  if (Counter1 % 20 ==0)
  {              
    if (CountKeys>0) CountKeys--;
  }

  if (Counter1==62)
  {
    NeedDisplaying=true;
    flNeedReadAlarm=true;
  }

  if (Counter1 % 20 ==0)
  {
    if (StateVolts==4) 
    {
      StateVolts=0; // Раз в 1/5 секунды запускаем измерение среднеквадратичного (в дальнейшем можно будет настроить, 
                    // чтобы оно делалось так часто, насколько позволяют возможности контроллера).
    }
    
  }
  Counter1++;
  if (Counter1>=125)
  {

    if (CountState>0) 
    {   if (CountState==1) lcd.clear();
        CountState--;
    }
    Seconds++;
    Counter1=0;
    NeedDisplaying=true;
    flNeedReadAlarm=true;
    
    // Если контроллер используется как термостат, или это уже чтение готового результата, то читаем раз в секунду.
    // Или мы сейчас вводим поправки.
    if (IspReg==102 || StepOut!=0 || FlState==300) 
    {
        flNeedTemp=1; // Устанавливаем флаг того, что надо читать температуру
     }
     else
     {
         // Иначе запускаем расчет один раз в 5 секунд (чтоб поменьше мограл регулятор мощности).
          if (Seconds % 5==0) flNeedTemp=1; 
     }
    
  }

  if (CountState<=0) 
   {
    FlState=0;
    CountState=0;
   }  
   
  // Сброс таймера
  TCNT2=0x00;
}


// Функция вызывается по прерыванию нуля от нуля сети 220 вольт
void zero_crosss_int()  // function to be fired at the zero crossing to dim the light
{
    unsigned char i;
    unsigned char flOpenClose;
    if (UstPower>=Power)
    {
      // Если мощность больше или равна номинальной, включаем триак всегда, при этом прерывание на закрытие никогда не выполнится.  
    TimeOpenTriac=5000;
      digitalWrite(PIN_TRIAC, HIGH);  
    }
    
    TicZero=(int) TCNT5L | (int) (TCNT5H<<8); // Расчитывааем текущее значение таймера
    // Сбрасываем 5-й таймер.
    TCNT5H=0x00;
    TCNT5L=0x00;
    
    TimeOpenTriacFact=(unsigned long) TimeOpenTriac * TicZero / TicSqNapr;
    
//    TimeOpenTriacFact=TimeOpenTriac;
    //TimeOpenTriac=2000;
    // В прерывании нуля настраиваем, чтобы прерывание на 5-м таймере выдалось через то время, которое мы ранее рассчитали.
    OCR5AH=(char)(TimeOpenTriacFact>>8);
    OCR5AL=(char)TimeOpenTriacFact;
    
    if (TimeOpenKLP==0) TimeOpenKLP=5000;
    
    OCR5BH=(char)(TimeOpenKLP>>8);
    OCR5BL=(char)TimeOpenKLP;
    
    // В прерывании нуля управляем открытием клапанов (а их лучше открывать по 0, чтобы не было помех)
    if (!flSyncKLP) // Если клапана не находятся в режиме синхронизации
    {
      for (i=0;i<MAX_KLP;i++)
      {
          // Разбираемся с состоянием клапана
          if (KlState[i]==0)
          {
            flOpenClose=0;
            // Состояние клапана - выключен            
            if (KlCount[i]>KlClose[i]) // Если количество тиков превышает установленное для состояния "закрыто", переводим клапан в состояние "открыто"
             {
                // Клапан переводим в состояние-включен
                KlState[i]=1;
                KlCount[i]=0;
                if(KlOpen[i]) flOpenClose=1;
             } 
          }
          else
          { 
            flOpenClose=1;
            // Состояние клапана - выключен
            if (KlCount[i]>KlOpen[i]) // Если количество тиков превышает установленное для состояния "открыто", переводим клапан в состояние "открыто"
             {
                KlState[i]=0;
                KlCount[i]=0;
               if(KlClose[i]) flOpenClose=0;
             } 
          }
          
          // Если клапан в принципе не должен выключаться то всегда переводим в состояние влкючен
          if (KlClose[i]==0) 
            {  flOpenClose=1;
               KlState[i]=1; 
            }
          // Если клапан в принципе не должен включатся,то всегда переводим  в состояние выключаем
          if (KlOpen[i]==0) 
            {
              flOpenClose=0;
               KlState[i]=0; 
            }
          
          // С состоянием клапана разобрались, тепер в зависимости от состояния включаем или выключаем его
          
          if (!flOpenClose)
          {  // Если клапан-выключен, то выключаем его в любом случае
            digitalWrite(PIN_KLP_BEG+i, LOW);  
          }
          else
          {  // Если состояние клапана - включен, включаем его только в том случае, если клапан в находится в режиме ШИМ
             // Или клапан находится в режиме фазового управления, но включен менее, чем полсекунды назад, или время фазового управления еще не рассчитано, то включаем его тоже,
             // иначе для режима фазового управления клапан включится по принципу фазового управления в прерывании.
              if (KlReg[i]==0 || KlCount[i]<50 || TimeOpenKLP==5000 )
                digitalWrite(PIN_KLP_BEG+i, HIGH);
                
          }
          
          KlCount[i]++;
      }    
    }

}

// Функция вызывается по прерыванию нуля от трансформатора (из-за сдвига фазы от нуля она вызывается не в то же время, что и прерывание от нуля 220 вольт)
// Пока это прерывание не используется и наверное нужно не будет
void zero_crosss_trans()  
{
}

void my_lcdprint(char *s)
{ char i;
  char len;
  len=strlen(lcd_buffer);  
  for(i=len;i<16;i++) s[i]=' ';
  s[16]=0;
  lcd.print(s);  
}


void DisplayData()
{
  int tic1;
  unsigned char hour,minute,second;
  int V1,V2;
  static int PrevState=0;
  
  hour=Seconds / 3600;
  tic1=Seconds % 3600;
  minute=tic1 / 60;
  second=tic1 % 60;   

  if (FlState==0) 
    lcd.setCursor(0, 0);
  else 
  { 
    // Если предыдущее состояние было 0, то даем задерку в 1/10 секунды, чтобы не слишком часто обновлялся
    // дисплей.
    if (PrevState==0)  delay(100);
    
    if (FlState!=PrevState)
    {
      lcd.clear();  //очистка дисплея   
      PrevState=FlState;
    }
    
   lcd.setCursor(0, 0);
  }
    
    switch (FlState)
    {
        case 0:
            
            switch (IspReg)
            {
                case 101: // Displaying
                    //sprintf(lcd_buffer,"S=%5u TT=%5u",Seconds,MaxTimeTimer); //запись в буфер текста и значений температуры в подготовленном
                    
                    //  Выводим сетевое напряжение по тому же принципу, что и работают дешевые вольтметры, то есть максимальное количество вольт в сети умножаем на 0,707
                    //  это напряжение нужно для калибровки нашего измерителя
                    
                    if (DispPage==0) 
                    {
                      sprintf(lcd_buffer,"%02u:%02u:%02u DSP 1/2",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                      my_lcdprint(lcd_buffer);
                      sprintf(lcd_buffer,"Zr=%4u U=%3u",TimeOpenTriac,(long) MaxVoltsOut*707/1000); //запись в буфер текста и значений температуры в подготовленном
                    }
                    
                    if (DispPage==1) 
                    {
                      V1=analogRead(A5);
                      V2=analogRead(A6);
                      sprintf(lcd_buffer,"D2 T=%3u,%3u,%3u",temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
                      my_lcdprint(lcd_buffer);
                      sprintf(lcd_buffer,"%3u, V=%4u,%4u",temps[3],V1,V2); //запись в буфер текста и значений температуры в подготовленном
                    }
                    lcd.setCursor(0, 1);
                    my_lcdprint(lcd_buffer);                      

                    break;
                case 102: // Термостат         
                    sprintf(lcd_buffer,"%02u:%02u:%02u TermSt",hour,minute,second,Delta); //запись в буфер текста и значений температуры в подготовленном
                    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
                    sprintf(lcd_buffer,"t=%3i/%3i(%2i) %1i",temps[TEMP_TERMOSTAT],TempTerm,Delta,StateMachine); //запись в буфер текста и значений температуры в подготовленном
                    break;
                case 103: // Регулятор мощности
                    sprintf(lcd_buffer,"%02u:%02u:%02u RMU=%3u",hour,minute,second,(long) MaxVoltsOut*707/1000); //запись в буфер текста и значений температуры в подготовленном
                    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
                    sprintf(lcd_buffer,"P=%4u/%4u",UstPowerReg,Power); //запись в буфер текста и значений температуры в подготовленном
                    break;
                case 105: // Отбор голов
                    if (DispPage==0)
                    {
                      switch (StateMachine)
                      { 
                        case 0: //Не запущено
                        case 1: //Нагрев до температуры 50 градусов
                          break;
                        case 2: //Ожидание закипания (прогреется дефлегматор)
                          sprintf(lcd_buffer,"%02u:%02u:%02u sGl Rzg",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
                          sprintf(lcd_buffer,"tD=%3i/%3i %4iW",temps[TEMP_DEFL],TempDeflBegDistil,Power); 
                          break;
                        case 3: //Ожидание закипания (прогреется куб дефлегматор)
                          sprintf(lcd_buffer,"%02u:%02u:%02u sGl Rzg",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
                          sprintf(lcd_buffer,"tK=%3i/%3i %4iW",temps[TEMP_KUB],TempDeflBegDistil,Power); 
                          break;
                        case 4: //Отбор голов
                          sprintf(lcd_buffer,"%02u:%02u:%02u sGl Otb",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
                          sprintf(lcd_buffer,"tK=%3i/%3i %4iW",temps[TEMP_KUB],Temp3P,PowerGlvDistil); 
                          break;
                        case 5: //Ожидание 60 секунд для охлаждения
                          sprintf(lcd_buffer,"%02u:%02u:%02u sOtbGlv",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
                          sprintf(lcd_buffer,"tK=%3i Wait=%4i",temps[TEMP_KUB],SecondsEnd); //запись в буфер текста и значений температуры в подготовленном
                          break;
                        case 100: //Окончание
                          sprintf(lcd_buffer,"%02u:%02u:%02u sOtbGlv",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
                          sprintf(lcd_buffer,"tK=%3i   end",temps[TEMP_KUB]); //запись в буфер текста и значений температуры в подготовленном
                          break;
                      }
                    }
                    else
                    {
                      V1=analogRead(A5);
                      V2=analogRead(A6);
                      sprintf(lcd_buffer,"D2 T=%3u,%3u,%3u",temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
                      my_lcdprint(lcd_buffer);
                      sprintf(lcd_buffer,"%3u, V=%4u,%4u",temps[3],V1,V2); //запись в буфер текста и значений температуры в подготовленном
                    }
                    
                    break;
                case 104: // Перевый (недробный) отбор
                case 106: // Второй дробный отбор
                case 107: // Третий дробный отбор
                   if (DispPage==0) 
                   {
                      if (IspReg==104) 
                      { V1=1;
                        V2=Temp1P;   
                      }
                      if (IspReg==106) 
                      { V1=2;
                        V2=Temp2P;   
                      }
                      if (IspReg==107) 
                      { V1=3;
                        V2=Temp3P;   
                      }
                      
                      sprintf(lcd_buffer,"%02u:%02u:%02u %1u-Otbor",hour,minute,second,V1); //запись в буфер текста и значений температуры в подготовленном
                      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
                      
                      switch (StateMachine)
                      { 
                        case 0: //Не запущено
                        case 1: //Нагрев до температуры 50 градусов
                          break;
                        case 2: //Ожидание закипания (прогреется дефлегматор)
                          sprintf(lcd_buffer,"tD=%3i/%3i %4iW",temps[TEMP_DEFL],TempDeflBegDistil,Power); 
                          break;
                        case 3: //Дистилляция
                          sprintf(lcd_buffer,"tK=%3i/%3i %4iW",temps[TEMP_KUB],V2,PowerDistil); 
                          break;
                        case 4: //Ожидание 60 секунд для охлаждения
                          sprintf(lcd_buffer,"tK=%3i Wait=%4i",temps[TEMP_KUB],SecondsEnd); //запись в буфер текста и значений температуры в подготовленном
                          break;
                        case 100: //Окончание
                          sprintf(lcd_buffer,"tK=%3i   end",temps[TEMP_KUB]); //запись в буфер текста и значений температуры в подготовленном
                          break;
                      }
                   }
                   else
                   {
                      sprintf(lcd_buffer,"D2/2 T=%3u, %3u ",temps[0],temps[1]); //запись в буфер текста и значений температуры в подготовленном
                      my_lcdprint(lcd_buffer);
                      sprintf(lcd_buffer,"%3u, %3u, %3u ",temps[2],temps[3],temps[4]); //запись в буфер текста и значений температуры в подготовленном
                   }
                   break;
                   
                case 108: // Разваривание
                    sprintf(lcd_buffer,"%02u:%02u:%02u Razvar",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
                      switch (StateMachine)
                      { 
                        case 0: //Не запущено
                          sprintf(lcd_buffer,"t=%3i P=%4i",temps[TEMP_RAZVAR],UstPower); //запись в буфер текста и значений температуры в подготовленном
                          break;
                        case 1: //Нагрев до температуры 50 градусов
                          sprintf(lcd_buffer,"t=%3i/500 %4iW",temps[TEMP_RAZVAR],UstPower); //запись в буфер текста и значений температуры в подготовленном
                          break;
                        case 2: //Поддержание температуры 50 градусов, пока не произойдет ручной переход к следующему этапу.
                          sprintf(lcd_buffer,"t=%3i Press Up",temps[TEMP_RAZVAR]); //запись в буфер текста и значений температуры в подготовленном
                          break;
                        case 3: //Нагрев до температуры 60 градусов
                          sprintf(lcd_buffer,"t=%3i/600 %4iW",temps[TEMP_RAZVAR],UstPower); //запись в буфер текста и значений температуры в подготовленном
                          break;
                        case 4: //Ожидание 15 минут, поддержка температуры
                          sprintf(lcd_buffer,"t=%3i %4iW %4i",temps[TEMP_RAZVAR],UstPower,SecondsEnd); //запись в буфер текста и значений температуры в подготовленном
                          break;
                        case 5: //Нагрев до 100 градусов
                          sprintf(lcd_buffer,"t=%3i/990 %4iW",temps[TEMP_RAZVAR],UstPower); //запись в буфер текста и значений температуры в подготовленном
                          break;
                        case 6: //Варим два часа
                          sprintf(lcd_buffer,"t=%3i %4iW %4i",temps[TEMP_RAZVAR],PowerRazvZerno,SecondsEnd); //запись в буфер текста и значений температуры в подготовленном
                          break;
                        case 100: //Окончание
                          sprintf(lcd_buffer,"t=%3i end       ",temps[TEMP_RAZVAR]); //запись в буфер текста и значений температуры в подготовленном
                          break;
                      }
                    break;
                case 109: // Ректификация
                    if (DispPage==0) 
                    {
                      switch (StateMachine)
                      { 
                        case 0: //Не запущено
                          sprintf(lcd_buffer,"%02u:%02u:%02u Rect",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                          //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
                          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
                          sprintf(lcd_buffer,"tK=%3i P=%4i",temps[TEMP_KUB],Power); //запись в буфер текста и значений температуры в подготовленном
                          break;
                        case 2: //Разгон
                          sprintf(lcd_buffer,"%02u:%02u:%02u R RZG",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                          //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
                          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
                          sprintf(lcd_buffer,"tK=%3i/%3i %4iW",temps[TEMP_KUB],tEndRectRazgon,UstPower); //запись в буфер текста и значений температуры в подготовленном
                          break;
                        case 3: //Стабилицация колонны
                          sprintf(lcd_buffer,"%02u:%02u:%02u R NSB",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                          //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
                          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
                          sprintf(lcd_buffer,"tN=%3i(%2i) %4uW",temps[TEMP_RK20],Seconds-SecTempPrev,UstPower); //запись в буфер текста и значений температуры в подготовленном
                          break;
                        case 4: //Отбор голов
                          sprintf(lcd_buffer,"%02u:%02u:%02u R GLV",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                          //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
                          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
                          sprintf(lcd_buffer,"tK=%3i/%3i %4uW",temps[TEMP_KUB],tEndRectOtbGlv,UstPower); //запись в буфер текста и значений температуры в подготовленном
                          break;
                        case 5: //Стоп, ожидание возврата температуры
                          sprintf(lcd_buffer,"%02u:%02u:%02u R Stop ",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                          //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
                          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
                          sprintf(lcd_buffer,"tN=%3i/%3i %2i%%",temps[TEMP_RK20],tStabSR,ProcChimSR); //запись в буфер текста и значений температуры в подготовленном
                          break;
                        case 6: //Ректификация
                          sprintf(lcd_buffer,"%02u:%02u:%02u RSt %2i%%",hour,minute,second,ProcChimSR); //запись в буфер текста и значений температуры в подготовленном
                          //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
                          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
                          sprintf(lcd_buffer,"tN=%3i/%3i/d%2i ",temps[TEMP_RK20],tStabSR+tDeltaRect,tDeltaRect); //запись в буфер текста и значений температуры в подготовленном
                          break;
                        case 7: //Отбор хвостов
                          sprintf(lcd_buffer,"%02u:%02u:%02u R Hvost",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                          //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
                          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
                          sprintf(lcd_buffer,"tK=%3i/%3i    ",temps[TEMP_KUB],tEndRect); //запись в буфер текста и значений температуры в подготовленном
                          break;
                        case 8: //Отбор ожидание 3 минут
                          sprintf(lcd_buffer,"%02u:%02u:%02u R Wait ",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                          //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
                          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
                          sprintf(lcd_buffer,"tK=%3i/%3i ",temps[TEMP_KUB],tEndRect); //запись в буфер текста и значений температуры в подготовленном
                          break;
                        case 100: //Окончание
                          sprintf(lcd_buffer,"%02u:%02u:%02u Rec End",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                          //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
                          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
                          sprintf(lcd_buffer,"tK=%3i/%3i ",temps[TEMP_KUB],tEndRect); //запись в буфер текста и значений температуры в подготовленном
                          break;
                      }
                    }
                    else
                    {
                      // На второй странице всегда показываем температуру датчиков
                      sprintf(lcd_buffer,"D2/2 T=%3u, %3u ",temps[0],temps[1]); //запись в буфер текста и значений температуры в подготовленном
                      my_lcdprint(lcd_buffer);
                      sprintf(lcd_buffer,"%3u, %3u, s%3u",temps[2],temps[3],Seconds-SecTempPrev); //запись в буфер текста и значений температуры в подготовленном
                    }
                    break;
                case 110: // Дистилляция с дефлегматором
                 if (DispPage==0) 
                 {
                    switch (StateMachine)
                    { 
                      case 0: //Не запущено
                      case 1: //Нагрев до температуры 50 градусов
                        sprintf(lcd_buffer,"%02u:%02u:%02u DD",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
                        sprintf(lcd_buffer,"tD=%3i/%3i %4iW",temps[TEMP_DEFL],TempDeflBegDistil,Power); 
                        break;
                      case 2: //Ожидание закипания (прогреется дефлегматор)
                        sprintf(lcd_buffer,"%02u:%02u:%02u DD Rzg",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
                        sprintf(lcd_buffer,"tD=%3i/%3i %4iW",temps[TEMP_DEFL],TempDeflBegDistil,Power); 
                        break;
                      case 3: //Ожидание закипания (прогреется куб дефлегматор)
                        sprintf(lcd_buffer,"%02u:%02u:%02u DD Rzg",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
                        sprintf(lcd_buffer,"tK=%3i/%3i %4iW",temps[TEMP_KUB],TempDeflBegDistil,Power); 
                        break;
                      case 4: //Работа без дефлегматора
                        sprintf(lcd_buffer,"%02u:%02u:%02u DD BezD",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
                        sprintf(lcd_buffer,"tD=%3i/%3i K=%3i",temps[TEMP_DEFL],TempDefl,temps[TEMP_KUB]); 
                        break;
                      case 5: //Работа с 50% дефлегмацией
                        sprintf(lcd_buffer,"%02u:%02u:%02u DD 50%%",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
                        sprintf(lcd_buffer,"tD=%3i/%3i K=%3i",temps[TEMP_DEFL],TempDefl-DeltaDefl,temps[TEMP_KUB]); 
                        break;
                      case 6: //Работа с 100% дефлегмацией
                        sprintf(lcd_buffer,"%02u:%02u:%02u DD 100%%",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
                        sprintf(lcd_buffer,"tD=%3i/%3i K=%3i",temps[TEMP_DEFL],TempDefl-DeltaDefl,temps[TEMP_KUB]); 
                         break;
                      case 7: //Ожидание для охлаждения
                         sprintf(lcd_buffer,"%02u:%02u:%02u DD Wait",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                         my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
                         sprintf(lcd_buffer,"tK=%3i Wait=%4i",temps[TEMP_KUB],SecondsEnd); //запись в буфер текста и значений температуры в подготовленном
                        break;
                      case 100: //Окончание
                        sprintf(lcd_buffer,"%02u:%02u:%02u DD end",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
                        sprintf(lcd_buffer,"tK=%3i   end",temps[TEMP_KUB]); //запись в буфер текста и значений температуры в подготовленном
                        break;
                    }
                 }
                 else
                    {
                      V1=analogRead(A5);
                      V2=analogRead(A6);
                      sprintf(lcd_buffer,"D2 T=%3u,%3u,%3u",temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
                      my_lcdprint(lcd_buffer);
                      sprintf(lcd_buffer,"%3u, V=%4u,%4u",temps[3],V1,V2); //запись в буфер текста и значений температуры в подготовленном
                    }
                  break;
                case 130: // Резерв
                    sprintf(lcd_buffer,"%02u:%02u:%02u Reserv",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                    //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
                    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
                    sprintf(lcd_buffer,"KLP %3i %3i /%1i",KlOpen[KlTek],KlClose[KlTek],KlTek); //запись в буфер текста и значений температуры в подготовленном
                    break;
               case 250:
                    sprintf(lcd_buffer,"ALARM VODA !"); //запись в буфер текста и значений температуры в подготовленном
                    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
//                    break;
                    
            }   
            // Это обычное состояние
//
            lcd.setCursor(0, 1);
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 100:
            sprintf(lcd_buffer,"UstParam",FlState); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 101:
            sprintf(lcd_buffer,"IsR = Displaying"); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 102:
            sprintf(lcd_buffer,"IsR = Termostat"); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 103:
            sprintf(lcd_buffer,"IsR = Reg Power"); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 104:
            sprintf(lcd_buffer,"IsR = 1 ND otbor"); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 105:
            sprintf(lcd_buffer,"IsR = otbor GLV"); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 106:
            sprintf(lcd_buffer,"IsR = 2 DR otbor"); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 107:
            sprintf(lcd_buffer,"IsR = 3 DR otbor"); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 108:
            sprintf(lcd_buffer,"IsR = Razvar"); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"Zerno",PowerRect); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 109:
            sprintf(lcd_buffer,"IsR = Rectif"); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 110:// Дистилляция с дефлегматором
            sprintf(lcd_buffer,"IsR = Dist Defl"); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 130:
            sprintf(lcd_buffer,"IsR = Reserv"); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"(%i)",FlState); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 200:
            sprintf(lcd_buffer,"Max_t_Tst=%5i",TempTerm); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 201:
            sprintf(lcd_buffer,"Power TEN=%5u",Power); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 202:
            sprintf(lcd_buffer,"Power Reg=%5u",UstPowerReg); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 203:
            sprintf(lcd_buffer,"ParamUSART=%u",FlToUSART); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 204:
            sprintf(lcd_buffer,"ParamGSM=%u",FlToGSM); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 205:
            sprintf(lcd_buffer,"dtTermostat=%3i",Delta); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 206:
            sprintf(lcd_buffer,"Temp 1 Nedrobn"); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"Distill=%3i   ",Temp1P); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 207:
            sprintf(lcd_buffer,"Temp 2 Drobn"); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"Distill=%3i",Temp2P); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 208:
            sprintf(lcd_buffer,"Temp 3 Drobn"); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"Distill=%3i",Temp3P); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 209:
            sprintf(lcd_buffer,"Temp Okon Razgon"); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"Rectif=%3i",tEndRectRazgon); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 210:
            sprintf(lcd_buffer,"Power"); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"Rectif=%3i",PowerRect); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 211:
            sprintf(lcd_buffer,"Vvod Popravok"); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"ds18b20 "); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 212:
            sprintf(lcd_buffer,"Temp Okon Otbor"); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"Glv Rectif=%3i",tEndRectOtbGlv ); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 213:
            sprintf(lcd_buffer,"CHIM Otbor GLV"); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"Rectif=%5i",timeChimRectOtbGlv); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 214:
            sprintf(lcd_buffer,"%% CHIM Otbor GLV"); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"Rectif=%3i",ProcChimOtbGlv); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 215:
            sprintf(lcd_buffer,"CHIM Otbor SR"); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"Rectif=%5i",timeChimRectOtbSR); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 216:
            sprintf(lcd_buffer,"Delta Otbor SR"); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"Rectif=%3u",tDeltaRect); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 217:
            sprintf(lcd_buffer,"Temp Okon Otbor"); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"SR Rectif=%3i",tEndRectOtbSR); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 218:
            sprintf(lcd_buffer,"Temp Okon"); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"Rectif=%3i",tEndRect); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 250:
            sprintf(lcd_buffer,"min %% CHIM"); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer," Otbor SR=%2i",minProcChimOtbSR); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 219:
            sprintf(lcd_buffer,"Power GLV simple"); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"Distill=%4i",PowerGlvDistil); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 220:
            sprintf(lcd_buffer,"Power simple"); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"Distill=%4i",PowerDistil); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 221:
            sprintf(lcd_buffer,"Temp Defl Begin"); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"Distill=%3i",TempDeflBegDistil); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 222:
            sprintf(lcd_buffer,"Temp Distill"); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"With Defl=%3i",TempDefl); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 223:
            sprintf(lcd_buffer,"Delta Distill"); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"With Defl=%3i",DeltaDefl); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 224:
            sprintf(lcd_buffer,"Temp Kub Okon"); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"DistWithDefl=%3i",tEndDistDefl); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 225:
            sprintf(lcd_buffer,"BeepEndProc=%1u",BeepEndProcess); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 226:
            sprintf(lcd_buffer,"BeepStateProc=%1u",BeepStateProcess); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 227:
            sprintf(lcd_buffer,"BeepKeyPress=%1u",BeepKeyPress); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 228:
            sprintf(lcd_buffer,"Power Razvar"); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"Zerno=%4i",PowerRazvZerno); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 300:
            sprintf(lcd_buffer,"Temp%1i=%3u",nPopr,temps[nPopr]); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"Popr=%3i T=%3u",ds1820_popr[nPopr], (temps[nPopr]+ds1820_popr[nPopr])); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        default:
        break;
    }

//    
//  lcd.setCursor(0, 0);
//  my_lcdprint(Seconds);
//  lcd.setCursor(5, 0);
//  my_lcdprint(MaxVoltsOut);
//  lcd.setCursor(9, 0);
//  my_lcdprint((long)MaxVoltsOut*707/1000);
//  lcd.setCursor(0, 1);
//  my_lcdprint(index_input);
//  lcd.setCursor(5, 1);
//  my_lcdprint(TimeOpenTriac);
//  NeedDisplaying=false;
//  lcd.setCursor(10, 1);
//  my_lcdprint(TicZero);

  NeedDisplaying=false;
 
}

void writeEEPROM()
{ int i; 
  ee_addr=0;
  eeWriteChar(PR_REWRITE_EEPROM);
  eeWriteChar(IspReg);
  eeWriteInt(Power);
  eeWriteInt(UstPowerReg);
  eeWriteInt(TempTerm);
  eeWriteInt(Delta);
  eeWriteChar(FlToUSART);
  eeWriteChar(FlToGSM);
  eeWriteInt(Temp1P);
  eeWriteInt(Temp2P);
  eeWriteInt(Temp3P);
  for(i=0;i<MAX_DS1820;i++)
    eeWriteChar(ds1820_popr[i]);
    
  eeWriteInt(tEndRectRazgon);
  eeWriteInt(PowerRect);
  
  eeWriteInt(tEndRectOtbGlv);
  eeWriteInt(timeChimRectOtbGlv);
  eeWriteChar(ProcChimOtbGlv);
  eeWriteInt(timeChimRectOtbSR);
  eeWriteChar(tDeltaRect);
  eeWriteInt(tEndRectOtbSR);
  eeWriteInt(tEndRect);
  eeWriteInt(PowerGlvDistil);
  eeWriteInt(PowerDistil);
  
  eeWriteInt(TempDeflBegDistil);
  eeWriteInt(TempDefl);
  eeWriteChar(DeltaDefl);

  eeWriteChar(BeepEndProcess);
  eeWriteChar(BeepStateProcess);
  eeWriteChar(BeepKeyPress);
  
  eeWriteInt(PowerRazvZerno);

  eeWriteInt(tEndDistDefl);
  eeWriteChar(minProcChimOtbSR);

}

void readEEPROM()
{
  int i; 
  ee_addr=0;
  eeReadChar();
  IspReg=eeReadChar();
  Power=eeReadInt();
  UstPowerReg=eeReadInt();
  TempTerm=eeReadInt();
  Delta=eeReadInt();
  FlToUSART=eeReadChar();
  FlToGSM=eeReadChar();
  Temp1P=eeReadInt();
  Temp2P=eeReadInt();
  Temp3P=eeReadInt();
  for(i=0;i<MAX_DS1820;i++)
    ds1820_popr[i]=eeReadChar();
  tEndRectRazgon=eeReadInt();
  PowerRect=eeReadInt();
  
  tEndRectOtbGlv=eeReadInt();
  timeChimRectOtbGlv=eeReadInt();
  ProcChimOtbGlv=eeReadChar();
  timeChimRectOtbSR=eeReadInt();
  tDeltaRect=eeReadChar();
  tEndRectOtbSR=eeReadInt();
  tEndRect=eeReadInt();
  PowerGlvDistil=eeReadInt();
  PowerDistil=eeReadInt();
  
  TempDeflBegDistil=eeReadInt();
  TempDefl=eeReadInt();
  DeltaDefl=eeReadChar();

  BeepEndProcess=eeReadChar();
  BeepStateProcess=eeReadChar();
  BeepKeyPress=eeReadChar();
  
  PowerRazvZerno=eeReadInt();

  tEndDistDefl=eeReadInt();
  minProcChimOtbSR=eeReadChar();

}


void ScanKbd()
{
   char i;
   // Если режим защиты от дребезга уже выключен
   if (CountKeys==0)
   {

//        if (PINB.0==0 && PINA.1==0)
//        {
//            Seconds=0;
//            CountKeys=6;     
//            for(i=0;i<4;i++)
//            {
//                KlState[i]=0;
//                KlCount[i]=0;
//            }
//            DisplayData();
//            return;            
//        }
        
//        if (PINA.2==0 && PINB.1==0)
//        {                
//            KlTek++;
//            if (KlTek>2) KlTek=0;
//            CountKeys=12;
//            DisplayData();
//            FlAnIsp=0;
//            return;            
//        }
            
            
        if (PRESS_LEFT && PRESS_RIGHT)
        {
            if (BeepKeyPress) my_beep(2);
            lcd.begin(16, 2);
            lcd.clear();
            DisplayData();
        }
        

        // Нажатие кнопок одновременно ввехр и вниз позволяет перейти к следующему этапу (отладочные кнопки)
        if (PRESS_UP && PRESS_DOWN)
        {
          if (BeepKeyPress) my_beep(2);
          StateMachine++; // Состояние конечного автомата процесса ректификации
          CountKeys=10; // Большая защита от дребезга, чтоб случайно не нажали.
          DisplayData();

        }
    
        if (PRESS_SELECT)
        {            
          if (BeepKeyPress) my_beep(1);
//            if (IspReg==9)
//            {  if (FlAnIsp==0)
//                { CountKeys=3;
//                  FlAnIsp=1;
//                  return;
//                }
//               
//            }               
//            FlAnIsp=0;
             switch (FlState)
             {         
                case 0:   
                
                    FlState=IspReg;
                    break;
                case 100:
                    FlState=200;      
                    break;   
                case 101:
                    FlState=0;      
                    IspReg=101;   
                    writeEEPROM();
                    break;   
                case 102:
                    if (IspReg!=102)
                    {
                      Seconds=0;
                      flAlarmUroven=0;
                      StateMachine=0;
                    }
                    if (!StateMachine) StateMachine=1;
                    IspReg=102;
                    writeEEPROM();
                    FlState=200;
                    break;    
                case 200:
                    FlState=0;
                    writeEEPROM();
                    break;    
                case 103:
                    IspReg=103;
                    writeEEPROM();
                    FlState=202;
                    break;    
                case 201:
                    writeEEPROM();
                    FlState=0;
                      break;     
                case 202:
                    writeEEPROM();
                    FlState=0;
                    break;     
                case 104:
                    // Если ранее был выбран другой тип отбора, сбрасываем состояние автомата в начальное.
                    if (IspReg!=104)
                    {
                      Seconds=0;
                      flAlarmUroven=0;
                      StateMachine=0;
                    }
                    if (!StateMachine) StateMachine=1;
                    IspReg=104;
                    writeEEPROM(); 
                    FlState=206;
                    break;     
                case 105:  
                    // Если ранее был выбран другой тип отбора, сбрасываем состояние автомата в начальное.
                    if (IspReg!=105) 
                    {
                      Seconds=0;
                      flAlarmUroven=0;
                      StateMachine=0;
                    }                      
                    if (!StateMachine) StateMachine=1;
                    IspReg=105;
                    writeEEPROM();
                    FlState=221;
                    break;     
                case 106:
                    // Если ранее был выбран другой тип отбора, сбрасываем состояние автомата в начальное.
                    if (IspReg!=106)
                    {
                      Seconds=0;
                      flAlarmUroven=0;
                      StateMachine=0;
                    }
                    if (!StateMachine) StateMachine=1;
                    IspReg=106;
                    writeEEPROM(); 
                    FlState=207;
                    break;     
                case 107:
                    // Если ранее был выбран другой тип отбора, сбрасываем состояние автомата в начальное.
                    if (IspReg!=107) 
                    {
                      Seconds=0;
                      flAlarmUroven=0;
                      StateMachine=0;
                    }
                    if (!StateMachine) StateMachine=1;
                    IspReg=107;
                    writeEEPROM();
                    FlState=208;
                    break;     
                case 108:
                    if (IspReg!=108) 
                    {
                      Seconds=0;
                      flAlarmUroven=0;
                      StateMachine=0;
                    }
                    if (!StateMachine) StateMachine=1;
                    IspReg=108;
                    FlState=0;
                    writeEEPROM();
                    break;
                case 109:
                    // Если ранее был выбран другой тип отбора, сбрасываем состояние автомата в начальное.
                    if (IspReg!=109)
                    {
                      Seconds=0;
                      flAlarmUroven=0;
                      StateMachine=0;
                    }
                    if (!StateMachine) StateMachine=1;
                   
                    IspReg=109;
                    FlState=209;
                    writeEEPROM();
                    break;
                case 110:  
                    // Если ранее был выбран другой тип отбора, сбрасываем состояние автомата в начальное.
                    if (IspReg!=110) // Если состояние автомата - не запущено, запускаем процесс
                    {
                      Seconds=0;
                      flAlarmUroven=0;
                      StateMachine=0;
                    }
                    if (!StateMachine) StateMachine=1;
                    
                    IspReg=110;
                    writeEEPROM();
                    FlState=220;
                    break;     
                case 130:
                    if (IspReg!=130) 
                    {
                      Seconds=0;
                      flAlarmUroven=0;
                      StateMachine=0;
                    }
                    if (!StateMachine) StateMachine=1;
                    IspReg=130;
                    writeEEPROM();
                    FlState=0;
                    break;     
                case 203:       
                case 204:       
                case 205:       
                case 206:       
                case 207:       
                case 208:       
                case 209:       
                case 210:       
                case 212:       
                case 213:       
                case 214:       
                case 215:       
                case 216:       
                case 217:       
                case 218:       
                case 219:       
                case 220:       
                case 221:       
                case 222:       
                case 223:       
                case 224:       
                case 225:       
                case 226:       
                case 227:       
                case 228:       
                case 250:     
                    writeEEPROM();
                    FlState=0;
                    break;    
                case 211:
                    FlState=300;
                    break;     
                case 300:       
                    writeEEPROM();
                    FlState=211;
                    break;    
             }                            
              DisplayData();
              CountState=4;
              if (CountKeys==0) CountKeys=6;              
              CountState=10;
                           
        }

        // Вторая  кнопка ( кнопка -)        
        if (PRESS_RIGHT)  
        { 
         if (BeepKeyPress) my_beep(1);
         switch (FlState)
         {                                              
            case 0:           
              if (DispPage<1) DispPage++;
              CountKeys=4;              
              break;
            case 100:
            case 101:
            case 102:
            case 103:
            case 104:
            case 105:
            case 106:
            case 107:
            case 108:
            case 109:
                FlState++;    
                break;   
            case 110:
                FlState=130;    
                break;   
            case 130:
                FlState=100;
                break;
            case 208:
                FlState=219;
                break;
            case 228:
                FlState=209;
                break;
            case 200:   
            case 201:
            case 202:
            case 203:
            case 204:
            case 205:
            case 206:
            case 207:
            case 209:
            case 210:
            case 211:
            case 212:
            case 213:
            case 214:
            case 215:
            case 216:
            case 217:
            case 219:
            case 220:
            case 221:
            case 222:
            case 223:
            case 224:
            case 225:
            case 226:
            case 227:
                FlState++;
                break;
            case 218:
                FlState=250;
                break;
            case 250:
                FlState=200;
                break;
            case 300:
                if (nPopr<MAX_DS1820-1) nPopr++;
                break;
          }
          
          //NeedDisplaying=1;
          DisplayData();
          if (CountKeys==0) CountKeys=6;
            
          CountState=4;
          CountState=40;
          
               
        }               
                         
        // первая  кнопка  (кнопка +)      
        
        if (PRESS_LEFT)
        { 
         if (BeepKeyPress) my_beep(1);
         switch (FlState)
         {

            case 0:          
              if (DispPage>0) DispPage--;
              CountKeys=4;              
              break;
            case 100:
                FlState=130;   
                break;
            case 101:
            case 102:
            case 103:
            case 104:
            case 105:
            case 106:
            case 107:
            case 108:
            case 109:
            case 110:
                FlState--;   
                break;
            case 130:
                FlState=110;   
                break;
            
            case 209: 
                FlState=227;   
                break;
            case 219: 
                FlState=208;   
                break;
            case 201:   
            case 202:
            case 203:
            case 204: 
            case 205: 
            case 206: 
            case 207: 
            case 208: 
            case 210: 
            case 211: 
            case 212:
            case 213:
            case 214:
            case 215:
            case 216:
            case 217:
            case 218:
            case 220:
            case 221:
            case 222:
            case 223:
            case 224:
            case 225:
            case 226:
            case 227:
            case 228:
               FlState--;
               break;
            case 250:
                FlState=218;
                break;
            case 200:
                FlState=250;
                break;     
            case 300:
                if (nPopr>0) nPopr--;
                break;
         }         
                 
          //NeedDisplaying=1;
          DisplayData();
          flNeedAnalyse=1;
          CountState=4;
          CountState=40;
          if (CountKeys==0) CountKeys=6;
        }
        


        if (PRESS_UP)  
        { 
         if (BeepKeyPress) my_beep(1);
         CountState=0;
         switch (FlState)
         {                                              
            case 0:
              // В сотоянии 0 обработка клавиш происходит за выходом модели этого конечного автомата.

             // Ректификация
             if (IspReg==109)
             {
                switch(StateMachine)
                {
                  case 2:
                    tEndRectRazgon++;
                    break;
                  case 3:
                    PowerRect+=10;
                    CountKeys=3;
                    break;
                  case 4:
                    tEndRectOtbGlv++;
                    break;
                  case 5:
                    tStabSR++;
                    break;
                  case 6:
                    ProcChimSR++;
                    break;
                  case 7:
                    tEndRect++;
                    break;
                }
             }
             
             // Регулятор мощности
             if (IspReg==103)
             {
                UstPowerReg+=10;
                //TekPower=(unsigned long) UstPower*220*220/ Power;
                CountKeys=3;
             }
             
             if (IspReg==104)
             {
                if (StateMachine==2) 
                  TempDeflBegDistil++;
                else
                  Temp1P++;
             }
             if (IspReg==106)
             {
                if (StateMachine==2) 
                  TempDeflBegDistil++;
                else
                  Temp2P++;
             }
             
             if (IspReg==107)
             {
                if (StateMachine==2) 
                  TempDeflBegDistil++;
                else
                  Temp3P++;
             }
             
             if (IspReg==105)
             {
               if (StateMachine==4) PowerGlvDistil+=10;
               if (StateMachine==2 || StateMachine==3) TempDeflBegDistil++;
             }
             
             if (IspReg==108)
             {
                 if (StateMachine==2) 
                 {
                   StateMachine=3;
                   CountKeys=6;
                 }
                 else
                    PowerRazvZerno+=10;

             }
             
             if (IspReg==110)
             {
                if (StateMachine==2) 
                  TempDeflBegDistil++;
                else
                  TempDefl++;
             }
             
             break; 
            case 200:
               TempTerm++;
               CountKeys=3;
               break;
            case 201:
               Power+=10;
               CountKeys=3;
               break;
            case 202:
                UstPowerReg+=10;
                CountKeys=3;
                break;
            case 203:
                FlToUSART=1;
                break;
            case 204:   
                FlToGSM=1;
                break;                     
            case 205:   
                Delta++;
                CountKeys=3;
                break;                     
            case 206:   
                Temp1P++;
                CountKeys=3;
                break;                     
            case 207:   
                Temp2P++;
                CountKeys=3;
                break;                     
            case 208:   
                Temp3P++;
                CountKeys=3;
                break;                     
            case 209:   
                if (tEndRectRazgon<920)
                          tEndRectRazgon++;
                CountKeys=3;
                break;                     
            case 210:   
                PowerRect+=10;
                CountKeys=3;
                break;                     
            case 212:
                tEndRectOtbGlv++;
                CountKeys=3;
                break;                     
            case 213:
                timeChimRectOtbGlv+=10;
                CountKeys=3;
                break;
            case 214:
                ProcChimOtbGlv++;
                CountKeys=4;
                break;
            case 250:
                minProcChimOtbSR++;
                CountKeys=4;
                break;
            case 215:
                timeChimRectOtbSR+=10;
                CountKeys=3;
                break;
            case 216:
                tDeltaRect++;
                CountKeys=4;
                break;
            case 217:
                tEndRectOtbSR++;
                CountKeys=3;
                break;
            case 218:
                tEndRect++;
                CountKeys=3;
                break;
            case 219:
                PowerGlvDistil+=10;
                CountKeys=3;
                break;
            case 220:
                PowerDistil+=10;
                CountKeys=3;
                break;
            case 221:
                TempDeflBegDistil++;
                CountKeys=3;
                break;
            case 222:
                TempDefl++;
                CountKeys=3;
                break;
            case 223:
                DeltaDefl++;
                CountKeys=3;
                break;
            case 224:
                tEndDistDefl++;
                CountKeys=3;
                break;
            case 225:
                BeepEndProcess=1;
                break;
            case 226:
                BeepStateProcess=1;
                break;
            case 227:
                BeepKeyPress=1;
                break;
            case 228:
               PowerRazvZerno+=10;
               CountKeys=3;
               break;
            case 300:   
                ds1820_popr[nPopr]++;
                CountState=8; // При вводе поправок сохраняем состояние 4 секунды, а не две, тут спешка не нужна.                
                CountKeys=4;
                break;                     
         }         
                 
          //NeedDisplaying=1;
          DisplayData();
          flNeedAnalyse=1;
          if (CountState==0) CountState=4;
          if (CountKeys==0) CountKeys=6;
          CountState=40;
       }
       

      if (PRESS_DOWN)  
      { 
       if (BeepKeyPress) my_beep(1);
       CountState=0;
       switch (FlState)
         {                                              
            case 0:
              // В сотоянии 0 обработка клавиш происходит за выходом модели этого конечного автомата.

             // Ректификация
             if (IspReg==109)
             {
                switch(StateMachine)
                {
                  case 2:
                    tEndRectRazgon--;
                    break;
                  case 3:
                    PowerRect-=10;
                    CountKeys=3;
                    break;
                  case 4:
                    tEndRectOtbGlv--;
                    break;
                  case 5:
                    tStabSR--;
                    break;
                  case 6:
                    ProcChimSR--;
                    break;
                  case 7:
                    tEndRect--;
                    break;
                }
             }
             
             // Регулятор мощности
             if (IspReg==103)
             {
                UstPowerReg-=10;
                //TekPower=(unsigned long) UstPower*220*220/ Power;
                CountKeys=3;
             }
             if (IspReg==104)
             {
                if (StateMachine==2) 
                  TempDeflBegDistil--;
                else
                  Temp1P--;
             }
             if (IspReg==106)
             {
                if (StateMachine==2) 
                  TempDeflBegDistil--;
                else
                  Temp2P--;
             }
             
             if (IspReg==107)
             {
                if (StateMachine==2) 
                  TempDeflBegDistil--;
                else
                  Temp3P--;
             }
             
             if (IspReg==105)
             {
               if (StateMachine==4) PowerGlvDistil-=10;
               if (StateMachine==2 || StateMachine==3) TempDeflBegDistil--;
             }

             if (IspReg==108)
             {
               PowerRazvZerno-=10;
             }
             
             if (IspReg==110)
             {
                if (StateMachine==2) 
                  TempDeflBegDistil--;
                else
                  TempDefl--;
             }

             break; 
            case 200:
               TempTerm--;
               CountKeys=3;
               break;
            case 201:
               Power-=10;
               CountKeys=3;
               break;
            case 202:
                UstPowerReg-=10;
                CountKeys=3;
                break;
            case 203:
                FlToUSART=0;
                break;
            case 204:   
                FlToGSM=0;
                break;                     
            case 205:   
                Delta--;
                CountKeys=3;
                break;                     
            case 206:   
                Temp1P--;
                CountKeys=3;
                break;                     
            case 207:   
                Temp2P--;
                CountKeys=3;
                break;                     
            case 208:   
                Temp3P--;
                CountKeys=3;
                break;                     
            case 209:   
                if (tEndRectRazgon>800)
                            tEndRectRazgon--;
                CountKeys=3;
                break;                     
            case 210:   
                PowerRect-=10;
                CountKeys=3;
                break;                     
            case 212:
                tEndRectOtbGlv--;
                CountKeys=3;
                break;                     
            case 213:
                timeChimRectOtbGlv-=10;
                CountKeys=3;
                break;
            case 214:
                ProcChimOtbGlv--;
                CountKeys=4;
                break;
            case 250:
                minProcChimOtbSR--;
                CountKeys=4;
                break;
            case 215:
                timeChimRectOtbSR-=10;
                CountKeys=3;
                break;
            case 216:
                tDeltaRect--;
                CountKeys=4;
                break;
            case 217:
                tEndRectOtbSR--;
                CountKeys=3;
                break;
            case 218:
                tEndRect--;
                CountKeys=3;
                break;
            case 219:
                PowerGlvDistil-=10;
                CountKeys=3;
                break;
            case 220:
                PowerDistil-=10;
                CountKeys=3;
                break;
            case 221:
                TempDeflBegDistil--;
                CountKeys=3;
                break;
            case 222:
                TempDefl--;
                CountKeys=3;
                break;
            case 223:
                DeltaDefl--;
                CountKeys=3;
                break;
            case 224:
                tEndDistDefl--;
                CountKeys=3;
                break;
            case 225:
                BeepEndProcess=0;
                break;
            case 226:
                BeepStateProcess=0;
                break;
            case 227:
                BeepKeyPress=0;
                break;
            case 228:
               PowerRazvZerno-=10;
               CountKeys=3;
               break;
            case 300:   
                ds1820_popr[nPopr]--;
                CountState=8; // При вводе поправок сохраняем состояние 4 секунды, а не две, тут спешка не нужна.                
                CountKeys=4;
                break;                     
         }         
               
        //NeedDisplaying=1;
        DisplayData();
        if (CountState==0) CountState=4;
        if (CountKeys==0) CountKeys=6;
        CountState=40;
      }
   }
}



void ProcessRectif()
{

//#define KLP_NPG  0      // Номер клапана для управления НПГ (при дистилляции) 
//#define KLP_VODA 1      // Номер клапана для управления общей подачей воды в систему
//#define KLP_DEFL 2      // Номер клапана для подачи воды в дейфлегматор
//#define KLP_GLV_HVS  3       // Номер клапана отбора головных и хвостовых фракций
//#define KLP_SR   4      // Номер клапана отбора ректификата
//#define TEMP_KUB  0      // Номер датчика  термометра в кубе
//#define TEMP_RK20 1      // Номер датчика термометра в РК 20 см от насадки
//#define TEMP_TSA  2      // Номер термометра в трубке связи с атмосферой

   if (flAlarmUroven) 
    { // Переводим автомат в стадию завершения 
      StateMachine=8;
      SecTempPrev=Seconds;// Запомним время, когда закончилась ректификация
      if (BeepStateProcess) my_beep(BEEP_LONG);
    }
  

  switch  (StateMachine)
  {
    case 0: // Процесс не запущен
      break;
    case 1: // Начало процесса
          CloseAllKLP();
          KlReg[KLP_GLV_HVS]=PEREGREV_ON;
          KlReg[KLP_SR]=PEREGREV_ON;
          
          if (FlToGSM && lastSMSState!=StateMachine) StateToSMS();
          KlOpen[KLP_VODA]=PER_KLP_OPEN;
          KlClose[KLP_VODA]=PER_KLP_CLOSE;
          digitalWrite(PIN_REG_ON,HIGH);
          digitalWrite(PIN_RZG_ON,HIGH);
          digitalWrite(PIN_ALL_OFF,LOW);
          StateMachine=2;
          if (BeepStateProcess) my_beep(BEEP_LONG);
    case 2: // Разгон
      UstPower=Power; // Устанавливаем максимальную мощность для разгона
      
     if (temps[TEMP_KUB]<tEndRectRazgon) break;
     
     // Подаем питание на клапан дефлегматора
      KlOpen[KLP_DEFL]=PER_KLP_OPEN;
      KlClose[KLP_DEFL]=PER_KLP_CLOSE;
      TempPrev=temps[TEMP_RK20];
      SecTempPrev=Seconds; // Запоминаем дату последнего изменения температуры
      StateMachine=3;        
      digitalWrite(PIN_RZG_ON,LOW);
      if (BeepStateProcess) my_beep(BEEP_LONG);
    case 3:// Стабилизация температуры
      UstPower=PowerRect;
      if (temps[TEMP_RK20]>700) // Если температура больше 70 градусов (вдруг куб прогрелся, а колонна еще нет, нелогично, конечно, но на всякий случай учтем)
      {
        if (abs(temps[TEMP_RK20]-TempPrev)<2) //Если текущая температура колонны равна температуре, запомненной ранее за исключением погрешности 0,2 градуса
        {
          if (Seconds-SecTempPrev>60) //Если с момента последнего измерения прошло более 60 секунд, тогда считаем, что температура в колоенне стабилизировалась
           {
             // Переходим к следующему этапу - отбору голов. 
              StateMachine=4;        
              if (BeepStateProcess) my_beep(BEEP_LONG);
           }
          else
            break;
            
        }
        else
        {
           TempPrev=temps[TEMP_RK20];// Запоминаем температуру
           SecTempPrev=Seconds; // Запоминаем время последнего изменения температуры
           break;
        }
      }
      else
       break;
   case 4: // Отбор голов
      UstPower=PowerRect;
      //unsigned int timeChimRectOtbGlv=2000;  // Шим отбора голов (в полупериодах сетевого напряжения в данном случае это около 20 секунд)
      //unsigned char ProcChimOtbGlv=5;  // Процент ШИМ отбора голов (в данном случае это 5 процентов)
      // Устанавливаем клапан отбора хвостов и голов в соответвии с установленнным ШИМ
      //int tEndRectOtbGlv=854;     // Температура окончания отбора голов 85.4 С
      KlOpen[KLP_GLV_HVS]=((timeChimRectOtbGlv/10)*ProcChimOtbGlv)/10;
      KlClose[KLP_GLV_HVS]=timeChimRectOtbGlv-KlOpen[KLP_GLV_HVS];
      
      if (temps[TEMP_KUB]<tEndRectOtbGlv)
      {  // Пока температура в кубе не выросла выше окончания отбора голов, продолжаем это состояни
        break;       
      }
      // Если температура превысила указанный рубеж, то переходим в состояние отбора спирта-ректификата.
      // Клапан отбора голов и хвостов отключаем
      tStabSR=temps[TEMP_RK20];// Это температура, относительно которой будем стабилизировать отбор
      KlOpen[KLP_GLV_HVS]=0;
      KlClose[KLP_GLV_HVS]=10;
      ProcChimSR=90;
      StateMachine=5;        
      if (BeepStateProcess) my_beep(BEEP_LONG);
      
   case 5: // Ожидание, пока температура не вернется к состоянию стабилизации
      // Это для отладки страт-стопа, на самом деле температура 28,5 градуса в этом режиме в колонне быть не может
      if (tStabSR==0) tStabSR=285;
      
      KlOpen[KLP_SR]=0;
      KlClose[KLP_SR]=10;
      if (temps[TEMP_RK20]>tStabSR)
      {
        break;
      }
      SecTempPrev=Seconds;// Запомним время, когда стабилизировалась температура
      StateMachine=6;        
      if (BeepStateProcess) my_beep(BEEP_LONG);
   case 6: // Отбор СР
    //unsigned int timeChimRectOtbSR=1000;  // Шим отбора СР (в полупериодах сетевого напряжения в данном случае это около 10 секунд)
    //unsigned char tDeltaRect=10;  // Дельта ректификации (в десятых градуса Цельсия) в данном случае - это 10 десятых, то есть 1 градус Цельсия
    //unsigned int tEndRectOtbSR=965;  // Температура окончания отбора спирта-ректификата и начала отбора хвостов (в данном случе 96.5 С)
    // Устанавливаем ШИМ отбора СР
      KlOpen[KLP_SR]=((timeChimRectOtbSR/10)*ProcChimSR)/10;
      KlClose[KLP_SR]=timeChimRectOtbSR-KlOpen[KLP_SR];
      if (temps[TEMP_RK20]>tStabSR+tDeltaRect) // Если текущая температура превысила базовую 
      {
        //Если температура превысилась менее, чем за одну минуту
        if (Seconds-SecTempPrev<60)
          {
            ProcChimSR-=10; // Тогда уменьшаем ШИМ на 10 
            if (ProcChimSR<minProcChimOtbSR) ProcChimSR=minProcChimOtbSR;
          }
          
        if (Seconds-SecTempPrev>600) // Если стабилизировалось более, чем за 10 минут, тогда прибавляем ШИМ на 5%
          {
            ProcChimSR+=5; // Тогда увеличиваем ШИМ на 5%
          }
         StateMachine=5;        
         if (BeepStateProcess) my_beep(BEEP_LONG);
      }
      else // Если температура не выросла более, чем за 10 минут, прибавим ШИМ на 5%
      {
        if (Seconds-SecTempPrev>720) // Если не стабилизировалось более, чем за 12 минут, тогда прибавляем ШИМ на 5%
          {
            ProcChimSR+=5; // Тогда увеличиваем ШИМ на 5%
            SecTempPrev=Seconds;// Запомним время, когда стабилизировалась температура
          }
      }

      // Если температура в кубе превысила температуру при которой надо отбирать СР
      if (temps[TEMP_KUB]>=tEndRectOtbSR)
      {  
         StateMachine=7;        
         KlOpen[KLP_SR]=0;// Отключаем клапана отбора СР
         KlClose[KLP_SR]=10;
        if (BeepStateProcess) my_beep(BEEP_LONG);
      }
      else    
        break;    
   case 7: // Отбор Хвостов
      KlOpen[KLP_GLV_HVS]=((timeChimRectOtbGlv/10)*90)/10;
      KlClose[KLP_GLV_HVS]=timeChimRectOtbGlv-KlOpen[KLP_GLV_HVS];
      if (temps[TEMP_KUB]>=tEndRect)
      {  
          StateMachine=8;        
          SecTempPrev=Seconds;// Запомним время, когда закончилась ректификация
         if (BeepStateProcess) my_beep(BEEP_LONG);
     }
      else    
        break;
   case 8:// Ждем три минуты для окончания подачи воды
     UstPower=0;
     KlOpen[KLP_GLV_HVS]=0;  // Отключаем клапана отбора хвостов
     KlClose[KLP_GLV_HVS]=10;
     
     if  (Seconds-SecTempPrev>180)
     {
          // Переводим автомат в конечное состояние
          StateMachine=100;        
          SecondsEnd=Seconds;
          if (BeepStateProcess) my_beep(BEEP_LONG);
     }
    break;
   case 100:// Конечное состояние автомата
       // Отключаем на всякий случай все!
      if (FlToGSM && lastSMSState!=StateMachine) StateToSMS();
      if (BeepEndProcess) my_beep(BEEP_LONG);
      UstPower=0;
      CloseAllKLP();
      digitalWrite(PIN_REG_ON,LOW);
      digitalWrite(PIN_RZG_ON,LOW);
      digitalWrite(PIN_ALL_OFF,HIGH);
    break;
  }
  
}

void ProcessSimpleDistill()
{
   int TekTemp;
   
  if (flAlarmUroven && StateMachine<4) 
  { // Переводим автомат в стадию завершения 
      StateMachine=4;        
      SecondsEnd=2*60;// Через две минуты отключим воду
      SecTempPrev=Seconds;
      if (BeepStateProcess) my_beep(BEEP_LONG);
  }

  switch  (StateMachine)
  {
    case 0: // Процесс не запущен
      break;
    case 1: // Начало процесса
          CloseAllKLP();
          if (FlToGSM && lastSMSState!=StateMachine) StateToSMS();
          KlOpen[KLP_VODA]=PER_KLP_OPEN;
          KlClose[KLP_VODA]=PER_KLP_CLOSE;
          StateMachine=2;
          if (BeepStateProcess) my_beep(BEEP_LONG);
          digitalWrite(PIN_REG_ON,HIGH);
          digitalWrite(PIN_RZG_ON,HIGH);
          digitalWrite(PIN_ALL_OFF,LOW);
    case 2: // Ожидание, пока прогреется термометр в дефлегматоре
    
      UstPower=Power; // Устанавливаем максимальную мощность для разгона
      
     // Если температура в дефлегматоре меньше 70 градусов и датчик дефлегматора в принципе подключен, тогда ждем, пока
     // дефлегматор прогреется, чтобы запустить воду в холодильник (это для некоторой экономии воды)
     if (temps[TEMP_DEFL]<TempDeflBegDistil && ds1820_devices>1) break;
     
     // Подаем питание на клапан подачи воды холодильника
     // для этого синхронизируем его с клапаном общей подачи воды (возможно, при этом будет меньше гидроударов, хотя я их и так не наблюдаю)
      flSyncKLP=true;
      KlOpen[KLP_HLD]=KlOpen[KLP_VODA];
      KlClose[KLP_HLD]=KlClose[KLP_VODA];
      KlState[KLP_HLD]=KlState[KLP_VODA];
      KlCount[KLP_HLD]=KlCount[KLP_VODA];
      flSyncKLP=false;
      StateMachine=3;        
      if (BeepStateProcess) my_beep(BEEP_LONG);
      digitalWrite(PIN_RZG_ON,LOW);
      
    case 3:// Ждем, пока температура в кубе не превысит установленную
      UstPower=PowerDistil; // Устанавливаем максимальную мощность для разгона
        
      if (IspReg==104) TekTemp=Temp1P; //Текущее состояние - первый недробный перегон
      if (IspReg==106) TekTemp=Temp2P; //Текущее состояние - второй дробный 
      if (IspReg==107) TekTemp=Temp3P; //Текущее состояние - третий дробный
    
      if (temps[TEMP_KUB]>=TekTemp)
      {  
          StateMachine=4;        
          SecondsEnd=2*60;// Через две минуты отключим воду
          SecTempPrev=Seconds;
          if (BeepStateProcess) my_beep(BEEP_LONG);
      }
      else    
        break;    
   case 4:// Ждем минуту для окончания подачи воды
     UstPower=0;
     SecondsEnd=SecondsEnd-(Seconds-SecTempPrev);
     SecTempPrev=Seconds;
     
      if (SecondsEnd<=0)
       {
          // Переводим автомат в конечное состояние
          StateMachine=100;        
          SecondsEnd=Seconds;
          if (BeepStateProcess) my_beep(BEEP_LONG);
       }
    break;
   case 100:// Конечное состояние автомата
       // Отключаем на всякий случай все!
      if (FlToGSM && lastSMSState!=StateMachine) StateToSMS();
      if (BeepEndProcess) my_beep(BEEP_LONG);
      UstPower=0;
      CloseAllKLP();
      digitalWrite(PIN_REG_ON,LOW);
      digitalWrite(PIN_RZG_ON,LOW);
      digitalWrite(PIN_ALL_OFF,HIGH);
    break;
  }
 
}

void CloseAllKLP()
{ char i;
    // Все клапана зануляем.
    for(i=0;i<MAX_KLP;i++)
    {
      KlOpen[i]=0;    
      KlClose[i]=10;   
      KlState[i]=0;          // Начальное состояние - клапан закрыт, счетчик 0
      KlCount[i]=0;  
      KlReg[i]=PEREGREV_ON;
    }
}

// Процесс отбора голов (без дефлегматора)
void ProcessSimpleGlv()
{

  if (flAlarmUroven && StateMachine<5) 
  { // Переводим автомат в стадию завершения 
      StateMachine=5;        
      SecondsEnd=60;// Через одну минуту отключим воду
      SecTempPrev=Seconds;
      if (BeepStateProcess) my_beep(BEEP_LONG);
  }

  switch  (StateMachine)
  {
    case 0: // Процесс не запущен
      break;
    case 1: // Начало процесса
          CloseAllKLP();
          if (FlToGSM && lastSMSState!=StateMachine) StateToSMS();
          KlOpen[KLP_VODA]=PER_KLP_OPEN;
          KlClose[KLP_VODA]=PER_KLP_CLOSE;
          StateMachine=2;
          digitalWrite(PIN_REG_ON,HIGH);
          digitalWrite(PIN_RZG_ON,HIGH);
          digitalWrite(PIN_ALL_OFF,LOW);
          if (BeepStateProcess) my_beep(BEEP_LONG);
    case 2: // Ожидание, пока прогреется термометр в дефлегматоре
    
      UstPower=Power; // Устанавливаем максимальную мощность для разгона
      
     // Если температура в дефлегматоре меньше 70 градусов и датчик дефлегматора в принципе подключен, тогда ждем, пока
     // дефлегматор прогреется, чтобы запустить воду в холодильник (это для некоторой экономии воды)
     if (temps[TEMP_DEFL]<TempDeflBegDistil && ds1820_devices>1) break;
     
     // Подаем питание на клапан подачи воды холодильника
      StateMachine=3;        
      if (BeepStateProcess) my_beep(BEEP_LONG);
    case 3:
     // Ждем, пока температура в кубе не достигнет температуры начала дистилляции (если есть датчик дефлегматора, тогда этот пункт сразу
     // проскочится, поскольку темперетура в кубе не может быть меньше, чем температура в дефлегматоре
     if (temps[TEMP_KUB]<TempDeflBegDistil) break;
     
     // Подаем питание на клапан подачи воды холодильника
      flSyncKLP=true;
      KlOpen[KLP_HLD]=KlOpen[KLP_VODA];
      KlClose[KLP_HLD]=KlClose[KLP_VODA];
      KlState[KLP_HLD]=KlState[KLP_VODA];
      KlCount[KLP_HLD]=KlCount[KLP_VODA];
      flSyncKLP=false;
      
      StateMachine=4;        
      if (BeepStateProcess) my_beep(BEEP_LONG);
      digitalWrite(PIN_RZG_ON,LOW);
    case 4:// Работа в режиме отбра голов идет исключетельно по наполнению приемной емкости, но все-таки температуру
    // на всякий случай анализируем, ведь температура в кубе при отборе голов, в любом случае не может быть больше, чем температура окончания
    // третьей дробной перегонки
    
      UstPower=PowerGlvDistil; // Устанавливаем мощность отбора голов.
      
      if (temps[TEMP_KUB]>=Temp3P)
      {  
          StateMachine=5;        
          SecondsEnd=1*60;// Через две минуты отключим воду
          SecTempPrev=Seconds;
          if (BeepStateProcess) my_beep(BEEP_LONG);
          
      }
      else    
        break;    
   case 5:// Ждем минуту для окончания подачи воды
     UstPower=0;
     SecondsEnd=SecondsEnd-(Seconds-SecTempPrev);
     SecTempPrev=Seconds;
     
      if (SecondsEnd<=0)
       {
          // Переводим автомат в конечное состояние
          StateMachine=100;        
          SecondsEnd=Seconds;
          if (BeepStateProcess) my_beep(BEEP_LONG);
       }
    break;
   case 100:// Конечное состояние автомата
       // Отключаем на всякий случай все!
      if (FlToGSM && lastSMSState!=StateMachine) StateToSMS();
      if (BeepEndProcess) my_beep(BEEP_LONG);
      UstPower=0;
      CloseAllKLP();
      digitalWrite(PIN_REG_ON,LOW);
      digitalWrite(PIN_RZG_ON,LOW);
      digitalWrite(PIN_ALL_OFF,HIGH);
    break;
  }
}


// Процесс дистилляции с подключаемым дефлегматором
// Процесс поддерживат температуру в дефлегматоре не более заданной + дельта и не менее заданной - дельта
void ProcessDistilDefl()
{

  // Если достигнут уровень в приемной емкости или температуре в кубе превысыла допустимую температуру для этого режима
  
  if ((flAlarmUroven || temps[TEMP_KUB]>=tEndDistDefl) && StateMachine<7) 
  { // Переводим автомат в стадию завершения 
      StateMachine=7;        
      SecondsEnd=2*60;// Через одну минуту отключим воду
      SecTempPrev=Seconds;
      if (BeepStateProcess) my_beep(BEEP_LONG);
  }
  

  switch  (StateMachine)
  {
    case 0: // Процесс не запущен
      break;
    case 1: // Начало процесса
          CloseAllKLP();
          if (FlToGSM && lastSMSState!=StateMachine) StateToSMS();
          KlOpen[KLP_VODA]=PER_KLP_OPEN;
          KlClose[KLP_VODA]=PER_KLP_CLOSE;
          StateMachine=2;//Этот процесс пока заблокирован, сразу идем на окончание.
          digitalWrite(PIN_REG_ON,HIGH);
          digitalWrite(PIN_RZG_ON,HIGH);
          digitalWrite(PIN_ALL_OFF,LOW);
          if (BeepStateProcess) my_beep(BEEP_LONG);
          
    case 2: // Ожидание, пока прогреется термометр в дефлегматоре
    
      UstPower=Power; // Устанавливаем максимальную мощность для разгона
      
     // Если температура в дефлегматоре меньше 70 градусов и датчик дефлегматора в принципе подключен, тогда ждем, пока
     // дефлегматор прогреется, чтобы запустить воду в холодильник (это для некоторой экономии воды)
     if (temps[TEMP_DEFL]<TempDeflBegDistil && ds1820_devices>1) break;
     
     // Подаем питание на клапан подачи воды холодильника
      StateMachine=3;        
      if (BeepStateProcess) my_beep(BEEP_LONG);

    case 3:
     // Ждем, пока температура в кубе не достигнет температуры начала дистилляции (если есть датчик дефлегматора, тогда этот пункт сразу
     // проскочится, поскольку темперетура в кубе не может быть меньше, чем температура в дефлегматоре
     if (temps[TEMP_KUB]<TempDeflBegDistil) break;
     // Подаем питание на клапан подачи воды холодильника
     
     // Подаем питание на клапан подачи воды холодильника
     // для этого синхронизируем его с клапаном общей подачи воды (возможно, при этом будет меньше гидроударов, хотя я их и так не наблюдаю)
      flSyncKLP=true;
      KlOpen[KLP_HLD]=KlOpen[KLP_VODA];
      KlClose[KLP_HLD]=KlClose[KLP_VODA];
      KlState[KLP_HLD]=KlState[KLP_VODA];
      KlCount[KLP_HLD]=KlCount[KLP_VODA];
      flSyncKLP=false;
      
      StateMachine=4;        
      if (BeepStateProcess) my_beep(BEEP_LONG);
      digitalWrite(PIN_RZG_ON,LOW);
      
    case 4: // Дефлегматор отключен.

      UstPower=PowerDistil; // Устанавливаем мощность дистилляции.
      
      if (temps[TEMP_DEFL]>TempDefl)
      {  
          // Включаем дефлегматор и холодильник
          flSyncKLP=true;
          KlOpen[KLP_DEFL]=KlOpen[KLP_VODA];
          KlClose[KLP_DEFL]=KlClose[KLP_VODA];
          KlState[KLP_DEFL]=KlState[KLP_VODA];
          KlCount[KLP_DEFL]=KlCount[KLP_VODA];
          KlOpen[KLP_HLD]=KlOpen[KLP_VODA];
          KlClose[KLP_HLD]=KlClose[KLP_VODA];
          KlState[KLP_HLD]=KlState[KLP_VODA];
          KlCount[KLP_HLD]=KlCount[KLP_VODA];
          flSyncKLP=false;
          StateMachine=5; // Переходим к этапу поддержания температуры путем частичной подачи воды в дефлегмато        
          if (BeepStateProcess) my_beep(BEEP_LONG);
      }
      else    
        break;    
        
    case 5:// 50% воды из холодильника идет в дефлегматор.
       UstPower=PowerDistil; // Устанавливаем мощность дистилляции.
      // Если температура превысила температуру, которую надо поддерживать в дефлегматоре+дельта, тогда переходим к режиму, когда
      // вся вода из холодильника идет через дефлегматор
      if (temps[TEMP_DEFL]>TempDefl+DeltaDefl)
      {  
          // Отключаем прямой выход из холодильника
          KlOpen[KLP_HLD]=0;
          KlClose[KLP_HLD]=10;
          // Включаем дефлегматор
          flSyncKLP=true;
          KlOpen[KLP_DEFL]=KlOpen[KLP_VODA];
          KlClose[KLP_DEFL]=KlClose[KLP_VODA];
          KlState[KLP_DEFL]=KlState[KLP_VODA];
          KlCount[KLP_DEFL]=KlCount[KLP_VODA];
          flSyncKLP=false;
          
          StateMachine=6; // Переходим к этапу поддержания температуры путем 100% направления воды в дефлегматор        
          if (BeepStateProcess) my_beep(BEEP_LONG);
      }
      else
       if (temps[TEMP_DEFL]<TempDefl-DeltaDefl) // Если в результате работы с 50% дефлегматором, температура понизилась переходим в режим работы без дефлегматора
       {
          KlOpen[KLP_DEFL]=0;
          KlClose[KLP_DEFL]=10;
          flSyncKLP=true;
          KlOpen[KLP_HLD]=KlOpen[KLP_VODA];
          KlClose[KLP_HLD]=KlClose[KLP_VODA];
          KlState[KLP_HLD]=KlState[KLP_VODA];
          KlCount[KLP_HLD]=KlCount[KLP_VODA];
          flSyncKLP=false;
          StateMachine=4; // Переходим к этапу без дефлегмации
          if (BeepStateProcess) my_beep(BEEP_LONG);
          break;
       }
      else    
        break;

    case 6: // Вся вода из холодильника идет в дефлегматор.
       UstPower=PowerDistil; // Устанавливаем мощность дистилляции.   
       if (temps[TEMP_DEFL]<TempDefl) // Если в результате работы с 100% дефлегматором, температура понизилась ниже установленной температуры переходим в режим работы с 50% дефлегма
       {
          // Включаем прямой выход из холодильника.
          flSyncKLP=true;
          KlOpen[KLP_HLD]=KlOpen[KLP_VODA];
          KlClose[KLP_HLD]=KlClose[KLP_VODA];
          KlState[KLP_HLD]=KlState[KLP_VODA];
          KlCount[KLP_HLD]=KlCount[KLP_VODA];
          KlOpen[KLP_DEFL]=KlOpen[KLP_VODA];
          KlClose[KLP_DEFL]=KlClose[KLP_VODA];
          KlState[KLP_DEFL]=KlState[KLP_VODA];
          KlCount[KLP_DEFL]=KlCount[KLP_VODA];
          flSyncKLP=false;
          StateMachine=5; // Переходим к этапу поддержания температуры 50% дефлегмацией
          if (BeepStateProcess) my_beep(BEEP_LONG);
          break;
      }
      else    
        break;
            
   case 7:// Ждем минуту для окончания подачи воды
     UstPower=0;
     SecondsEnd=SecondsEnd-(Seconds-SecTempPrev);
     SecTempPrev=Seconds;
     
      if (SecondsEnd<=0)
       {
          // Переводим автомат в конечное состояние
          StateMachine=100;        
          SecondsEnd=Seconds;
          if (BeepStateProcess) my_beep(BEEP_LONG);
      }
    break;
   case 100:// Конечное состояние автомата
       // Отключаем на всякий случай все!
      if (FlToGSM && lastSMSState!=StateMachine) StateToSMS();
      if (BeepEndProcess) my_beep(BEEP_LONG);
      UstPower=0;
      CloseAllKLP();
      digitalWrite(PIN_REG_ON,LOW);
      digitalWrite(PIN_RZG_ON,LOW);
      digitalWrite(PIN_ALL_OFF,HIGH);
      break;
  }
}


void ProcessRazvarZerno()
{
  switch (StateMachine)
  { 
    case 0: //Не запущено
      break;
    case 1: //Нагрев до температуры 50 градусов
      digitalWrite(PIN_RZG_ON,LOW);
    
      // Если необходимо отправлять состояние на сотовый и это состояние еще не отправлялось, тогда информируем о состоянии процесса
      if (FlToGSM && lastSMSState!=StateMachine) StateToSMS();
      
      if (temps[TEMP_RAZVAR]<500)
      {
        UstPower=Power;
        break;
      }
      StateMachine=2;
      if (BeepStateProcess) my_beep(BEEP_LONG);
      
    case 2: //Поддержание температуры 50 градусов, пока не произойдет ручной переход к следующему этапу.
      // Из этого режима можно выйти только вручную, нажав кнопку вверх или отладочной функцией одновременно нажав вверх и вниз.
      if (temps[TEMP_RAZVAR]<480)
      {
        UstPower=PowerRazvZerno;
      }
      if (temps[TEMP_RAZVAR]>=500)
      {
        UstPower=0;
      }
      break;
    case 3: //Нагрев до температуры 60 градусов
      if (temps[TEMP_RAZVAR]<600)
      {
        UstPower=Power;
        break;
      }
      StateMachine=4;
      if (BeepStateProcess) my_beep(BEEP_LONG);
      SecTempPrev=Seconds;
      SecondsEnd=15*60;
      
      #ifdef TEST
        SecondsEnd=1*60;// Отладка
      #endif
    case 4: //Ожидание 15 минут, поддержка температуры
      if (temps[TEMP_RAZVAR]<580)
      {
        UstPower=PowerRazvZerno;
      }
      if (temps[TEMP_RAZVAR]>=600)
      {
        UstPower=0;
      }
      SecondsEnd=SecondsEnd-(Seconds-SecTempPrev);
      SecTempPrev=Seconds;
      if (SecondsEnd<=0)
      {
          StateMachine=5;
          if (BeepStateProcess) my_beep(BEEP_LONG);
      }
      else
        break;
        
    case 5: //Нагрев до 100 градусов
      if (temps[TEMP_RAZVAR]<990)
      {
        UstPower=Power;
        break;
      }
      StateMachine=6;
      SecTempPrev=Seconds;
      SecondsEnd=2*60*60; // Это 2 часа в секундах 
      #ifdef TEST
        SecondsEnd=2*60;// Отладка
      #endif
      if (BeepStateProcess) my_beep(BEEP_LONG);
      
    case 6: //Варим два часа
      UstPower=PowerRazvZerno;
      SecondsEnd=SecondsEnd-(Seconds-SecTempPrev);
      SecTempPrev=Seconds;
      if (SecondsEnd<=0)
      {
          StateMachine=100;
          if (BeepStateProcess) my_beep(BEEP_LONG);
      }
      else
        break;
    case 100: //Окончание
      // Если необходимо отправлять состояние на сотовый и это состояние еще не отправлялось, тогда информируем о состоянии процесса
      if (FlToGSM && lastSMSState!=StateMachine) StateToSMS();
      if (BeepEndProcess) my_beep(BEEP_LONG);
      UstPower=0;
      CloseAllKLP();
      digitalWrite(PIN_REG_ON,LOW);
      digitalWrite(PIN_RZG_ON,LOW);
      digitalWrite(PIN_ALL_OFF,HIGH);
      break;
  }
  
}


void ProcessTermostat()
{
  switch  (StateMachine)
  {
    case 0: // Температура Больше необходиомй
       // Процесс не запущен
      break;
    case 1: // Старт процесса
        digitalWrite(PIN_TERMOSTAT_OFF,LOW);// Включаем охлаждение
        digitalWrite(PIN_TERMOSTAT_ON,LOW);// Выключаем нагрев
        StateMachine=2;
    case 2: // Температура Больше необходиомй
      if (temps[TEMP_TERMOSTAT]<=TempTerm)
      {
        digitalWrite(PIN_TERMOSTAT_OFF,LOW);// Включаем охлаждение
        digitalWrite(PIN_TERMOSTAT_ON,HIGH);// Выключаем нагрев
        break;
      }
      StateMachine=3;
      if (BeepStateProcess) my_beep(BEEP_LONG);
      
    case 3: //
      if (temps[TEMP_TERMOSTAT]>TempTerm-Delta)
      {
        digitalWrite(PIN_TERMOSTAT_ON,LOW);// Выключаем нагрев
        digitalWrite(PIN_TERMOSTAT_OFF,HIGH);// Включаем охлаждение
        break;
      }
      StateMachine=2;
      if (BeepStateProcess) my_beep(BEEP_LONG);
      break;
   case 100:// Конечное состояние автомата
      digitalWrite(PIN_TERMOSTAT_ON,LOW);// Выключаем нагрев
      digitalWrite(PIN_TERMOSTAT_OFF,LOW);// Включаем охлаждение
      
    break;
  }
}


//#define MSerial1 Serial2

void GetPhonePDU()
{
  unsigned char i;
  for(i=1;i<=9;i+=2)
  {
    pdu_phone[i-1]=my_phone[i+1];
    pdu_phone[i]=my_phone[i];
  }
  pdu_phone[10]='F';
  pdu_phone[11]=my_phone[11];
  pdu_phone[12]=0;
}

void toUSARTPDU(char *s)
{ 
    char ot[20];
    unsigned char i; 
    char pdu_header[]="0011000B91"; // Заголовок ПДУ.
    char pdu_poster[]="0008FF"; // Заключительная часть ПДУ.
    //unsigned char ot[6];
    //for(i=0;sms_message[i];out[i++]=0); // Очистить выходной массив
    
    sprintf(ot,"AT+CMGS=%2i",14+strlen(s)*2);// выводим количество окетов

//    sprintf(ot,"AT+CMGS=18");// выводим количество окетов
    
   // sprintf(ot,"AT+CMGS=%02X",13+strlen(s));// Если поставить 19, то уже не работает.
    
    Serial2.println(ot);
    // ждем пятую часть секунды.
    delay(200);
    
    // Выводим заголовок ПДУ
    Serial2.print(pdu_header);
    
    //+65027887074
    //Выводим номер телефона в ПДУ формате
//    for(i=1;i<=9;i+=2)
//    {
//      Serial2.write(my_phone[i+1]);
//      Serial2.write(my_phone[i]);
//    }
//    Serial2.write('F');
//    Serial2.write(my_phone[11]);
    
    // 
    
    Serial2.print(pdu_phone);
    Serial2.print(pdu_poster);
    
    // Выводим длину сообщения в шестнадцатеричном формате.
    sprintf(ot,"%02X",strlen(s)*2);
    Serial2.print(ot);
    // Выводим само сообщение
   
   for(i=0;s[i];i++)
   {
      sprintf(ot,"00%02X",s[i]);
      Serial2.print(ot);
   }
   
  Serial2.write(0x1A);

}


void GetState()
{
  int tic1;
  unsigned char hour,minute;
  hour=Seconds / 3600;
  tic1=Seconds % 3600;
  minute=tic1 / 60;
  
  sprintf(my_tx_buffer,"%02u:%02u I=%3u S=%3u T=%3u,%3u,%3u V=%4u,%4u",hour,minute,IspReg, StateMachine,temps[0],temps[1],temps[2],analogRead(PIN_ALARM_VODA),analogRead(PIN_ALARM_UROVEN));
}

void StateToSMS()
{
  GetState();
  toUSARTPDU(my_tx_buffer);
  // Запоминаем последнее переданное состояние на сотовый.
  lastSMSState=StateMachine;
}

void loop() 
{
  int i,j;
  unsigned long SqNapr=0,SqNaprPrev=0,FindPower,FindPowerKLP;
  unsigned int TimeOpenTriac1=0;
  int U1,U2; //Уровни на выводах
  byte data[12];
  char s_rx;
  byte present = 0;
  unsigned int raw;
  byte ds18b20CRC;
  static unsigned int SecondsRing;
  static char *vid_sms;   // Вид СМС - память или Сим-карта
  static char num_sms[10];// Номер СМС.
  static char flSMS=0; // Признак того, что приходила SMS и она еще не удалена.
  static char fAnGSM=0; // Состояние анализа входящего звонка
  static char  FlFindPower;
  static char  FlFindPowerKLP;
  
//  static int PowerPrev=0;
//  static int UstPowerPrev=0;
  // set the cursor to column 0, line 1
  // (note: line 1 is the second row, since counting begins with 0):
  // print the number of seconds since reset:
  // Если есть необходимость произвести отображениеш  информации на дисплее и среднеквадратичное уже рассчитано.
  // И контроллен находится в режиме "лазанья" по меню, тогда отображаем информацию.
  if (NeedDisplaying && (StateVolts!=1 || !STAB_RM) && FlState==0)
  {
    DisplayData();
  }
  

//  if (flNeedScanKbd==1)
//  {
//    flNeedScanKbd=0;
//  }

  if (StateVolts!=1 || !STAB_RM)                 
  {
    if (flNeedTemp==1)
    {
        if (StepOut==0)
        {
          ds.reset();
          ds.write(0xCC,1);         // start conversion, with parasite power on at the end
          ds.write(0x44,1);         // start conversion, with parasite power on at the end
          flNeedTemp=0;
          StepOut=1;
        }
        else
        {
          for (j=0;j<ds1820_devices;j++)
          {
            present=ds.reset();
            
            #ifdef TIMING
              TCNT4H=0x00;
              TCNT4L=0x00;
            #endif            
              
          // Здесь вообще засада, передача кода датчика занимает около 1600 тиков таймера, что гарантирует пропуск регуляции как минимум одного полупериода.
          // Возможно решение - посадить каждый датчик на отдельный ПИН, тогда код датчика передавать не нужно.
           ds.select(ds1820_rom_codes[j]);    
              
            #ifdef TIMING
              unsigned int Tic2=(int) TCNT4L | (int) (TCNT4H<<8); // Расчитывааем текущее значение таймера
              sprintf(my_tx_buffer,"TicDs18Select=%i",Tic2);
              FlUsart=1;
            #endif
            
            ds.write(0xBE);         // Read Scratchpad
  //          Serial1.print(present,HEX);
  //          Serial1.print(" ");
            //        Читаем пока только 2 байта из 9, остальные не трогаем.
            for ( i = 0; i < 9; i++) 
            {  
              data[i] = ds.read();
  //            Serial1.print(data[i], HEX);
  //            Serial1.print(" ");
            }
  //          Serial1.print(" CRC=");
            ds18b20CRC=OneWire::crc8(data, 8);
            if (ds18b20CRC!=data[8])
            {
                //  Ошибка чтения, возможно в дальнейшем надо перечитать.
                
            }
            
            raw = (data[1] << 8) | data[0];          
            temps[j]=raw*5/8;
            
            // Если мы сейчас не находимся в режиме ввода поправок к датчикам, то прибавляем к температуре значение поправки
            
            if (FlState!=300)
            {

              temps[j]=temps[j]+(int) ds1820_popr[j];
              
               #ifdef TEST
//                   sprintf(my_rx_buffer,"Temp(%1i)=%i ishod=%i popr=%i FlSt=%i",j,temps[j],raw*5/8,ds1820_popr[j],FlState);
//                   FlUsart=1;
               #endif
              
              
            }
  //          Serial1.print(OneWire::crc8(data, 8), HEX);
  //          Serial1.println();
  //          
  //          Serial1.print(j);
  //          Serial1.print(" ");
  //          Serial1.print(temps[j]);
  //          
  //          Serial1.println();          
            
  //          temps[j] = temps[j] *5 / 8;
          } 
          
         StepOut=0;
         flNeedAnalyse=1;   // Все необходимые данные прочитаны устанавливаем флаг того, что нужно анализировать состояние выполнения процесса.
         flNeedTemp=0;
        }
        
    }
  }
  
  // Выполняем процесс.
  // Сработка датчика уровня НПГ
  if (flNeedReadAlarm && (StateVolts!=1 || !STAB_RM))
  {
    if (NPG_UROVEN)
    {
      KlOpen[KLP_NPG]=1;
      KlClose[KLP_NPG]=1;
    }  
    else
    {
      KlOpen[KLP_NPG]=0;
      KlClose[KLP_NPG]=10;
    }  
    
    
    U1=analogRead(PIN_ALARM_VODA);    
    
    if (U1<UROVEN_ALARM)
      {
        CountAlarmVoda++;
        
        #ifdef TEST
          sprintf(my_tx_buffer,"ALARM U1=%i cnt=%i",U1,CountAlarmVoda);
          Serial1.println(my_tx_buffer);
        #endif      
        
        if (CountAlarmVoda>2 && USE_ALARM_VODA)
        {
          flNeedAnalyse=1;
          #ifndef TEST
            IspReg=250;      // Переводим контроллер в режим тревоги, если не установлен тестовый режим.
          #endif
        }
        
      }
    else 
      CountAlarmVoda=0;
    
    U2=analogRead(PIN_ALARM_UROVEN);    
    if (U2<UROVEN_ALARM)
      {
        CountAlarmUroven++;
        #ifdef TEST
          sprintf(my_tx_buffer,"ALARM U2=%i cnt=%i",U2,CountAlarmUroven);
          Serial1.println(my_tx_buffer);
        #endif      
  
        if (CountAlarmUroven>2 && USE_ALARM_UROVEN)
        {
          flAlarmUroven=1;
          flNeedAnalyse=1;
        } 
      }
    else 
      CountAlarmUroven=0;
    
   flNeedReadAlarm=false; 
  }

  
  if (flNeedAnalyse==1)
  {
      #ifdef TEST
        Serial1.println("BEGIN PROSSES");
      #endif      

    switch(IspReg)
      {
        case 102: //Текущее состояние - термостат
          ProcessTermostat();
          break;
        case 103: //Текущее состояние - регулятор мощности
          UstPower=UstPowerReg;
          break;
        case 108:
          ProcessRazvarZerno();
          break;
        case 109: //Текущее состояние - ректификация
          ProcessRectif();
          break;
        case 104: //Текущее состояние - первый недробный перегон
        case 106: //Текущее состояние - второй дробный
        case 107: //Текущее состояние - третий дробный
          ProcessSimpleDistill();
          break;
        case 105: //Текущее состояние - отбор голов
          ProcessSimpleGlv();
          break;
        case 110:
          ProcessDistilDefl();
          break;
        case 130:
          if (StateMachine==1) // Если состояние автомата - не запущено
          {
//            flRing=1;
            flSyncKLP=true;
              KlOpen[KLP_VODA]=PER_KLP_OPEN;
              KlClose[KLP_VODA]=PER_KLP_CLOSE;
              KlOpen[KLP_HLD]=KlOpen[KLP_VODA];
              KlClose[KLP_HLD]=KlClose[KLP_VODA];
              KlState[KLP_HLD]=KlState[KLP_VODA];
              KlCount[KLP_HLD]=KlCount[KLP_VODA];
              KlOpen[KLP_DEFL]=KlOpen[KLP_VODA];
              KlClose[KLP_DEFL]=KlClose[KLP_VODA];
              KlState[KLP_DEFL]=KlState[KLP_VODA];
              KlCount[KLP_DEFL]=KlCount[KLP_VODA];
              KlOpen[KLP_SR]=KlOpen[KLP_VODA];
              KlClose[KLP_SR]=KlClose[KLP_VODA];
              KlState[KLP_SR]=KlState[KLP_VODA];
              KlCount[KLP_SR]=KlCount[KLP_VODA];
             digitalWrite(PIN_TERMOSTAT_ON,HIGH);
             digitalWrite(PIN_TERMOSTAT_OFF,HIGH);
//             digitalWrite(30,HIGH);
//             digitalWrite(31,HIGH);
//             digitalWrite(32,HIGH);
              
              
            flSyncKLP=false;

            StateMachine=100; // Переводим процесс в состояние выполнения
          }
          break;          
        case 250:
          // Тревога протечка воыд, отключаем воду, отключаем мощность.
          UstPower=0;
          CloseAllKLP();
          // Пищим, независимо от настроек.
          #ifndef TEST
            my_beep(125*4);
          #endif
          break;
          
          
      }

      #ifdef TEST
        Serial1.println("END PROSSES");
      #endif      
      
    flNeedAnalyse=0;
  }
  


//  анализ сотового   
   if (Serial2.available() > 0) 
   {  //если есть доступные данные
       // считываем байт
       s_rx=Serial2.read();
       
       #ifdef TESTGSM
         // Дублируем информацию на Serial1
         Serial1.write(s_rx);
       #endif
       
       switch(fAnGSM)
       {
         case 0:
           
           if (s_rx==10)
           {
             my_rx_buffer[pos_rx_buffer-1]=0;
             if (strlen(my_rx_buffer)<40)
             {
               if (!strcmp("RING",my_rx_buffer)) // Если входящий звонок, то определяем номер.
               {
                 Serial2.println("AT+CLCC");
                 fAnGSM=1;
               }
               else
               {
                  vid_sms=strstr(my_rx_buffer,"+CMTI:");
                  if (vid_sms)
                  {
                    vid_sms+=6;
                    vid_sms[5]=0;
                    // Запоминаем номер СМС.
                    strcpy(num_sms,&vid_sms[6]);
                    // Выдаем запрос на чтение смс из того места, откуда она пришла.
                    #ifdef TESTGSM
  //                    Serial1.println("TEST SMS:");
  //                    Serial1.println(num_sms);
  //                    Serial1.println(vid_sms);
  //                    Serial1.println("END TEST:");
                    #endif 
                    
                    Serial2.print("AT+CPMS=");
                    Serial2.println(vid_sms);
                    delay(200);
                    // Читаем СМС с заданным номером.
                    Serial2.print("AT+CMGR=");
                    Serial2.println(num_sms);
                    flSMS=1;
                  }
                  
                 
               }
             }
             else
             { // Если сообщение больше, чем 60 символом, считмаем, что это SMS, полученный из телефона.
                #ifdef TESTGSM
                  Serial1.print("GETSMS:");
                  Serial1.println(my_rx_buffer);
                #endif 
                // Ищем в СМС свой номер телефона
                vid_sms=strstr(my_rx_buffer,pdu_phone);
                
                #ifdef TESTGSM
                  Serial1.print("addr:");
                  Serial1.println((int)vid_sms,HEX);
                #endif 
                
                if (vid_sms)
                {// Если найден номер телефона, тогда выделяем информацию из него
                 // Информацией считаем последние четыре принятых байта (то есть один символ в формате Unicode)
                 //   
                  vid_sms=my_rx_buffer+strlen(my_rx_buffer)-4;
                  #ifdef TESTGSM
                    Serial1.print("INFOSMS:");
                    Serial1.println(vid_sms);
                  #endif 
                  // Если получили команду на включение котроллера, устанавливаем состояние машины в первое рабочее.
                  if(!strcmp(sms_start,vid_sms)) 
                  {
                    #ifdef TESTGSM
                      Serial1.println("Start on SMS");
                    #endif 
                    StateMachine=1;
                  }
                  // Если получили команду на включение котроллера, устанавливаем состояние машины в конечное.
                  if(!strcmp(sms_stop,vid_sms)) 
                  {
                    StateMachine=100;
                    #ifdef TESTGSM
                      Serial1.println("Stop on SMS");
                    #endif 
                    
                  }
                  
                  
                }
                // Если ранее был установлен признак SMS, то удаляем SMS c заданным номером.
                
                
                if (flSMS)
                {
                  
                  #ifdef TESTGSM
                    Serial1.print("DELETING:");
                    Serial1.println(num_sms);
                  #endif 
                
                  Serial2.print("AT+CMGD=");
                  Serial2.println(num_sms);
                  flSMS=0;
                }
             }
    
             pos_rx_buffer=0;
             #ifdef TESTGSM
//               lcd.clear();
//               my_lcdprint(my_rx_buffer);
//               delay(1000);
             #endif 
             my_rx_buffer[0]=0;
             
             // Небольшая задержка, на всякий случай чтобы успел телефон обработать 
             
           }
           else
           {
             if (pos_rx_buffer>=MY_RX_BUFFER_SIZE) pos_rx_buffer=0;
             my_rx_buffer[pos_rx_buffer]=s_rx;
             pos_rx_buffer++;
           }
           break;
       case 1:// Ждем первую кавычку
         if (pos_rx_buffer>=MY_RX_BUFFER_SIZE) fAnGSM=0;
         pos_rx_buffer++;
         if (s_rx=='"') 
         {   pos_rx_buffer=0;
             fAnGSM=2;
         } 
         break;
       case 2:// Ждем вторую кавычку
         if (s_rx==10) fAnGSM=0; // Если встретили возврат каретки, то возврат к обычному режиму 
         if (s_rx=='"') 
         { // Нашли номер
           // Отклоняем вызов.
           Serial2.println("AT+CHUP");
           // Небольшая задержка, на всякий случай чтобы успел телефон обработать 
          delay(200);
           my_rx_buffer[pos_rx_buffer]=0;
           if (!strcmp(my_rx_buffer,my_phone)) flRing=1;
           
           #ifdef TESTGSM
             lcd.clear();
             lcd.print(my_rx_buffer);
             delay(1000);
           #endif
           
           fAnGSM=0;
         }
         else
         {
            if (pos_rx_buffer>=MY_RX_BUFFER_SIZE) pos_rx_buffer=0;
            my_rx_buffer[pos_rx_buffer]=s_rx;
            pos_rx_buffer++;
         }
       }  
   }
   else
   {
     if (flRing==1)
     {
      
        #ifdef TESTGSM
          lcd.clear();
          lcd.print("my call");
          delay(1000);
        #endif
        delay(200);
        // Выдаем состояние состояние контроллера по SMS, вне зависимости от того, указано в настройках отправлять СМС или нет.
        // Ведь для чего-то мы на сотовый звонили?
        StateToSMS();
        
        #ifdef TESTGSM
          Serial1.println(my_tx_buffer);
        #endif
        
        flRing=0;
     }
   }
// Окончание анализа сотового  

  if (FlUsart==1)
  {
      // Признак того, что надо выдать информацию в ком-порт (есл ее вдруг невозможно сразу выдать, например, из прерывания).
      Serial1.println(my_tx_buffer);
      FlUsart=0;    
  }       
  
  
// Начало расчета среднеквадратичного
  if (StateVolts==2)        
  {
     #ifdef TESTRM
        Serial1.println("BEGIN SQNAPR");
     #endif      
    
     StateVolts=3;

    //    if (UstPower!=PowerPrev)
//    {
      // поскольку тут идет преобразование и умножение 32 разрядных чисел, делаем это по необходимости, а не каждый раз (хотя какая разница, тут и таких умножений дохрена)
      TekPower=(unsigned long) UstPower*220*220/ Power;
      TekPowerKLP=(unsigned long) NAPR_PEREGREV*NAPR_PEREGREV;
//      PowerPrev=UstPower;
//    }

    SqNapr=0;
    SqNaprPrev=0;    
    FindPower=TekPower*index_input;
    FindPowerKLP=TekPowerKLP*index_input;
    
    j=0;
    TimeOpenTriac1=0;
    
    
    FlFindPower=false;
    FlFindPowerKLP=false;

    if (Power<=UstPower)  FlFindPower=true;
      
    for(i=index_input-1;i>=0;i--)
    {
      SqNapr=SqNapr+(unsigned long) data_adc[i]* (unsigned long) data_adc[i];
      if (SqNapr>=FindPower && !FlFindPower) 
      { 
        // Рассчитали среднеквадратичное
        TimeOpenTriac1=tic_adc[i]+ (SqNapr-FindPower)*(tic_adc[i+1]-tic_adc[i])/(SqNapr-SqNaprPrev);
        // Присвоили текущие значения
        TimeOpenTriac=TimeOpenTriac1;
        TicSqNapr=tic_adc[index_input-1]; // Количство тиков таймера, на основании которого расчитано среденеквадратичное.
        FlFindPower=true;
        j=i;
      }
      
      // Мощность клапана точно не подбираем, просто берем первую большую, чем задано.
      if (SqNapr>=FindPowerKLP && !FlFindPowerKLP) 
      {
        TimeOpenKLP=tic_adc[i];
        FlFindPowerKLP=true;
      }
      if (FlFindPower && FlFindPowerKLP) break;
      
      SqNaprPrev=SqNapr;
    } 
      
      
    
    #ifdef TESTRM
    
      Serial1.println("VOLTS");
      Serial1.print("OpenTriac=");
      Serial1.println(TimeOpenTriac);
      Serial1.print("OpenKLP=");
      Serial1.println(TimeOpenKLP);

      Serial1.print("COUNT=");
      Serial1.println(index_input);
      
      for(i=0;i<index_input;i++)
      {            
      
          Serial1.print(tic_adc[i]);
          Serial1.write(9);
          Serial1.println(data_adc[i]);
      }                                                    
      Serial1.print("TICZERO=");
      Serial1.write(9);
      Serial1.print(TicZero);
      Serial1.write(9);
      Serial1.println(TicSqNapr);
      
      Serial1.println("ENDVOLTS");
          
    
    #endif      
    
   StateVolts=4;
  }
// окончание  расчета среднеквадратичного

}





